if not PlayerMenu then	
	--------------
	---- GAME ----
	--------------
	-- NO HIT DISORIENTATION
	local function nohitdis()
		Toggle.no_hit_disorient = not Toggle.no_hit_disorient

		if not Toggle.no_hit_disorient then
			backuper:restore("CoreEnvironmentControllerManager.hit_feedback_front")
			backuper:restore("CoreEnvironmentControllerManager.hit_feedback_back")
			backuper:restore("CoreEnvironmentControllerManager.hit_feedback_right")
			backuper:restore("CoreEnvironmentControllerManager.hit_feedback_left")
			backuper:restore("CoreEnvironmentControllerManager.hit_feedback_up")
			backuper:restore("CoreEnvironmentControllerManager.hit_feedback_down")
			ChatMessage('Disabled', 'NO HIT DISORIENTATION')
			return
		end
		
		backuper:backup("CoreEnvironmentControllerManager.hit_feedback_front")
		function CoreEnvironmentControllerManager:hit_feedback_front() end
		
		backuper:backup("CoreEnvironmentControllerManager.hit_feedback_back")
		function CoreEnvironmentControllerManager:hit_feedback_back() end
		
		backuper:backup("CoreEnvironmentControllerManager.hit_feedback_right")
		function CoreEnvironmentControllerManager:hit_feedback_right() end
		
		backuper:backup("CoreEnvironmentControllerManager.hit_feedback_left")
		function CoreEnvironmentControllerManager:hit_feedback_left() end
		
		backuper:backup("CoreEnvironmentControllerManager.hit_feedback_up")
		function CoreEnvironmentControllerManager:hit_feedback_up() end
		
		backuper:backup("CoreEnvironmentControllerManager.hit_feedback_down")
		function CoreEnvironmentControllerManager:hit_feedback_down() end
		ChatMessage('Enabled', 'NO HIT DISORIENTATION')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INTERACTION LOOKAROUND
	local function interactlook()
		Toggle.check_action_interact = not Toggle.check_action_interact

		if not Toggle.check_action_interact then
			backuper:restore('PlayerStandard._check_action_interact')
			ChatMessage('Disabled', 'INTERACT LOOK AROUND')
			return
		end

		backuper:backup('PlayerStandard._check_action_interact')
		function PlayerStandard:_check_action_interact(t, input)
			local new_action,timer,interact_object
			local interaction_wanted = input.btn_interact_press
			self._unit:base():set_slot(self._unit, 4)
			if interaction_wanted then
				local action_forbidden = self:chk_action_forbidden("interact") 
				or self._unit:base():stats_screen_visible() or self:_interacting()
				or self._ext_movement:has_carry_restriction() or self:is_deploying()
				or self:_changing_weapon()
				if not action_forbidden then	
					new_action,timer,interact_object = managers.interaction:interact(self._unit)
					if new_action then
						self:_play_interact_redirect(t, input)
					end	
					if timer then
						new_action = true
						self:_start_action_interact(t, input, timer, interact_object)
					end
					new_action = new_action or self:_start_action_intimidate(t)
				end	
			end
			if input.btn_interact_release then
				self:_interupt_action_interact()
			end
			return new_action
		end
		ChatMessage('Enabled', 'INTERACT LOOK AROUND')	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	-- INTERACT DISTANCE INCREASE
	local function intdist()
		Toggle.interact_distance = not Toggle.interact_distance

		if not Toggle.interact_distance then
			backuper:restore('BaseInteractionExt.interact_distance')
			ChatMessage('Disabled', "INTERACT DISTANCE INCREASE")
			return
		end
		
		backuper:backup('BaseInteractionExt.interact_distance')
		function BaseInteractionExt:interact_distance()
			if self.tweak_data == "access_camera" or self.tweak_data == "shaped_sharge" or tostring(self._unit:name()) == "Idstring(@ID14f05c3d9ebb44b6@)"
			or self.tweak_data == "burning_money" or self.tweak_data == "stn_int_place_camera"  or self.tweak_data == "trip_mine" then
				return self._tweak_data.interact_distance or tweak_data.interaction.INTERACT_DISTANCE
			end
			return MVPConfig.Interact_Distance_Amount or 200 -- DEFAULT IS 200
		end
		ChatMessage('Enabled', "INTERACT DISTANCE INCREASE")	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	-- NO SPOOC DOWN SELF ONLY CUFF
	function spooccuffselfon()
		Toggle.on_SPOOCed = not Toggle.on_SPOOCed

		if not Toggle.on_SPOOCed then
			backuper:restore('PlayerMovement.on_SPOOCed')
			ChatMessage('Disabled', 'CLOAKER CUFF')
			return
		end

		backuper:backup('PlayerMovement.on_SPOOCed')
		function PlayerMovement:on_SPOOCed()
			if self._unit:character_damage()._god_mode then
				return
			end
			if self._current_state_name == "standard" or self._current_state_name == "bleed_out" then
				managers.player:set_player_state( "arrested" )
		end	end
		ChatMessage('Enabled', 'CLOAKER CUFF')	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- GOD MODE TOGGLE
	function godmode()
		Toggle.godLike = not Toggle.godLike
			
		-- GOD MODE OFF
		if not Toggle.godLike then
			managers.player:player_unit():character_damage():set_god_mode(false)
			ChatMessage('Disabled', 'GOD MODE')
			return
		end
		-- GOD MODE ON
		managers.player:player_unit():character_damage():set_god_mode(true)
		ChatMessage('Enabled', 'GOD MODE')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INSTANT INTERACT TOGGLE
	local function instantinteract()		
		Toggle.instant_interact = not Toggle.instant_interact
			
		-- DISABLE INSTANT INTERACTION/DEPLOY
		if not Toggle.instant_interact then
			backuper:restore('BaseInteractionExt._get_timer')
			backuper:restore('PlayerManager.selected_equipment_deploy_timer')
			ChatMessage('Disabled', 'INSTANT INTERACT')
			return
		end
	
		-- ENABLE INSTANT INTERACTION/DEPLOY
		backuper:backup('BaseInteractionExt._get_timer')
		function BaseInteractionExt:_get_timer() return 0 end
		
		backuper:backup('PlayerManager.selected_equipment_deploy_timer')
		function PlayerManager:selected_equipment_deploy_timer(self) return 0 end	
		ChatMessage('Enabled', 'INSTANT INTERACT')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INSTANT DRILL TOGGLE
	local function instantdrill()
		if isHost() then
			Toggle.timer_gui_instant_hack = not Toggle.timer_gui_instant_hack
			
			-- DISABLE
			if not Toggle.timer_gui_instant_hack then
				backuper:restore('TimerGui.update')
				ChatMessage('Disabled', 'INSTANT DRILL')
				return
			end

			-- ENABLE
			ChatMessage('Enabled', 'INSTANT DRILL')
			backuper:hijack('TimerGui.update',function( o, self, ... )
				self._current_timer = 0
				return o(self, ...)
			end)
		end 
	end 
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INTERACT WITH ANYTHING TOGGLE
	local function interactanyhting()
		Toggle.interact_with_all = not Toggle.interact_with_all
			
		-- DISABLE
		if not Toggle.interact_with_all then
			backuper:restore('BaseInteractionExt._has_required_upgrade')
			backuper:restore('BaseInteractionExt._has_required_deployable')
			backuper:restore('BaseInteractionExt.can_interact')
			backuper:restore('PlayerManager.remove_equipment')
			ChatMessage('Disabled', 'INTERACT WITH ANYTHING')
			return
		end
		
		-- ENABLE
		backuper:backup('BaseInteractionExt._has_required_upgrade')
		function BaseInteractionExt:_has_required_upgrade() return true end
		
		backuper:backup('BaseInteractionExt._has_required_deployable')
		function BaseInteractionExt:_has_required_deployable() return true end
		
		backuper:backup('BaseInteractionExt.can_interact')
		function BaseInteractionExt:can_interact() return true end
		
		backuper:backup('PlayerManager.remove_equipment')
		function PlayerManager:remove_equipment() end
		ChatMessage('Enabled', 'INTERACT WITH ANYTHING')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- SMALL LOOT MULTIPLIER TOGGLE
	function smlootmulti()
		Toggle.small_loot = not Toggle.small_loot
			
		-- DISABLE SMALL LOOT MODIFIER
		if not Toggle.small_loot then
			tweak_data.upgrades.values.player.small_loot_multiplier = {1.1, 1.3}
			ChatMessage('Disabled', 'SMALL LOOT MULTIPLIER')
			return
		end
		
		-- ENABLE SMALL LOOT MODIFIER
		tweak_data.upgrades.values.player.small_loot_multiplier = {MVPConfig.Small_Loot_Multiplier_Amount, MVPConfig.Small_Loot_Multiplier_Amount}
		ChatMessage('Enabled', 'SMALL LOOT MULTIPLIER')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INFINITE AMMO TOGGLE
	local function infammo()
		Toggle.infinite_ammo = not Toggle.infinite_ammo
			
		-- DISABLE INFINTE AMMO
		if not Toggle.infinite_ammo then
			backuper:restore('NewRaycastWeaponBase.fire')
			ChatMessage('Disabled', 'INFINITE AMMO')
			return
		end

		-- ENABLE INFINITE AMMO
        local _fireWep = backuper:backup('NewRaycastWeaponBase.fire')
		function NewRaycastWeaponBase:fire( from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul, target_unit )
            local result = _fireWep( self, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul, target_unit )
            if managers.player:player_unit() == self._setup.user_unit then
                self.set_ammo(self, 1.0)
            end
            return result
        end
		ChatMessage('Enabled', 'INFINITE AMMO')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INSTANT DOMINATE TOGGLE
	local function instantdom()		
		Toggle.instant_dominate_convert = not Toggle.instant_dominate_convert
		
		if not Toggle.instant_dominate_convert then
			backuper:restore('CopLogicIdle.on_intimidated')
			backuper:restore('CopLogicIntimidated.on_intimidated')
			backuper:restore('CopLogicSniper.enter')
			tweak_data.upgrades.values.player.convert_enemies_max_minions = {1,2}
			ChatMessage('Disabled', 'INSTANT DOMINATE')
			return
		end
		
		ChatMessage('Enabled', 'INSTANT DOMINATE')
		tweak_data.upgrades.values.player.convert_enemies = {true}
		tweak_data.upgrades.values.player.convert_enemies_max_minions = {999999,999999}

		CopLogicAttack.on_intimidated = CopLogicIdle.on_intimidated
		CopLogicArrest.on_intimidated = CopLogicIdle.on_intimidated
		CopLogicSniper.on_intimidated = CopLogicIdle.on_intimidated
		backuper:backup('CopLogicIdle.on_intimidated')
		function CopLogicIdle.on_intimidated(data, amount, aggressor_unit)
			CopLogicIdle._surrender(data, amount)
			return true
		end

		-- Setup logic for shields to be able to be intimidated
		CopBrain._logic_variants.shield.intimidated = CopLogicIntimidated
		CopLogicIntimidated._onIIntimidated = backuper:backup('CopLogicIntimidated.on_intimidated')
		function CopLogicIntimidated.on_intimidated(data, amount, aggressor_unit) 
			-- If shield we skip animations, go straight to conversion & spawn a new shield since it was destroyed during intimidation
			if data.unit:base()._tweak_table == "shield" then
				CopLogicIntimidated._do_tied(data, aggressor_unit)
				CopInventory._chk_spawn_shield( data.unit:inventory(), nil )
			else
				CopLogicIntimidated._onIIntimidated(data, amount, aggressor_unit)
			end	
		end
		
		-- Setup a proper sniper-rifle for snipers (100% accuracy, no spread)
		CopBrain._logic_variants.sniper = clone( CopBrain._logic_variants.security )
		CopBrain._logic_variants.sniper.attack = CopLogicSniper
		CopLogicSniper._onSniperEnter = backuper:backup('CopLogicSniper.enter')
		function CopLogicSniper.enter( data, new_logic_name, enter_params )
			if data.unit:brain()._logic_data and data.unit:brain()._logic_data.objective and data.unit:brain()._logic_data.objective.type == "follow" then
				data.char_tweak.weapon[ data.unit:inventory():equipped_unit():base():weapon_tweak_data().usage ] = tweak_data.character.presets.weapon.sniper.m4
				data.char_tweak.weapon[ data.unit:inventory():equipped_unit():base():weapon_tweak_data().usage ].spread = 0
				-- Get dat 100% accuracy
				for distance=1, 3 do
					for interpolate=1,2 do
						data.char_tweak.weapon[ data.unit:inventory():equipped_unit():base():weapon_tweak_data().usage ].FALLOFF[distance].acc[interpolate] = 1
					end	
				end	
			end
			CopLogicSniper._onSniperEnter(data, new_logic_name, enter_params)
		end	
	end			
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- INTERACT THRU WALL TOGGLE
	local function interactwall()	
		Toggle.interact_thru_wall = not Toggle.interact_thru_wall
		
		-- DISABLE INTERACT THRU WALL
		if not Toggle.interact_thru_wall then
			backuper:restore('ObjectInteractionManager._update_targeted')
			backuper:restore('ObjectInteractionManager.interact')
			ChatMessage('Disabled', 'INTERACT THRU WALL')
			return
		end

		-- ENABLE INTERACT THROUGH WALLS 
		backuper:backup('ObjectInteractionManager._update_targeted')
		function ObjectInteractionManager:interact( player )
			if( alive( self._active_object ) ) then
				local interacted,timer = self._active_object:interaction():interact_start( player )
				if timer then
					self._active_object_locked_data = true
				end
				return interacted or interacted == nil or false, timer, self._active_object
			end
			return false
		end

		backuper:backup('ObjectInteractionManager.interact')
		function ObjectInteractionManager:_update_targeted( player_pos, player_unit )	
			local mvec1 = Vector3()
			local mvec3_dis = mvector3.distance
			if( #self._close_objects > 0 ) then
				for k, v in pairs( self._close_objects ) do	
					if( alive( v ) and v:interaction():active() ) then
						if mvec3_dis( player_pos, v:interaction():interact_position() ) > v:interaction():interact_distance() then
							table.remove( self._close_objects, k )
						end
					else
						table.remove( self._close_objects, k )
					end	
				end	
			end
			
			for i = 1, self._close_freq, 1 do
				if( self._close_index >= self._interactive_count ) then
					self._close_index = 1
				else
					self._close_index = self._close_index + 1
				end
				local obj = self._interactive_objects[ self._close_index ]
				if( alive(obj) and obj:interaction():active() and not self:_in_close_list( obj ) ) then
					if( mvec3_dis(player_pos, obj:interaction():interact_position()) <= obj:interaction():interact_distance()  ) then
						table.insert( self._close_objects, obj )
					end	
				end	
			end
				
			local locked = false
			if self._active_object_locked_data then
				if not alive( self._active_object ) or not self._active_object:interaction():active() then
					self._active_object_locked_data = nil  
				else
					locked = ( mvec3_dis(player_pos, self._active_object:interaction():interact_position()) <= self._active_object:interaction():interact_distance() )
				end	
			end
			
			if locked then
				return
			end
			local last_active = self._active_object
			local blocked = player_unit:movement():object_interaction_blocked()
			if( #self._close_objects > 0 ) and not blocked then
				--find the one the player is looking at
				local active_obj = nil
				local current_dot = 0.9
				local player_fwd = player_unit:camera():forward()
				local camera_pos = player_unit:camera():position()
				tweak_data.interaction.open_from_inside.interact_distance = 0
				for k, v in pairs( self._close_objects ) do
					if( alive( v ) ) then
						mvector3.set( mvec1, v:interaction():interact_position() )
						mvector3.subtract( mvec1, camera_pos )
						mvector3.normalize( mvec1 )
						local dot = mvector3.dot( player_fwd, mvec1 )
						if( dot > current_dot ) then
							current_dot = dot
							active_obj = v
						end	
					end	
				end
					
				if( active_obj and self._active_object ~= active_obj ) then
					if alive( self._active_object ) then
						self._active_object:interaction():unselect()
					end
					if not active_obj:interaction():selected( player_unit ) then
						active_obj = nil
					end	
				end
				self._active_object = active_obj
			else
				self._active_object = nil
			end
			if( alive( last_active ) ) then
				if( not self._active_object ) then
					self._active_object = nil
					last_active:interaction():unselect()
				end	
			end	
		end
		ChatMessage('Enabled', 'INTERACT THRU WALL')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- BAG MOD TOGGLE
	local function carrymod()
		Toggle.toggleBagMods = not Toggle.toggleBagMods
		if Toggle.toggleBagMods then
			ChatMessage('Enabled', 'BAG MOD')
			local car_arr = {'being', 'mega_heavy', 'heavy', 'medium', 'light', 'coke_light', 'very_heavy', 'explosives'}
			for i, name in ipairs(car_arr) do
				if not tweak_data.carry.types["__" .. name] then
					tweak_data.carry.types["__" .. name] = clone(tweak_data.carry.types[name])
				end
				tweak_data.carry.types[name].throw_distance_multiplier = 1.5
				tweak_data.carry.types[name].move_speed_modifier = 1
				tweak_data.carry.types[name].jump_modifier = 1
				tweak_data.carry.types[name].can_run = true
				tweak_data.carry.types.explosives.can_explode = false					
			end
			function PlayerManager:carry_blocked_by_cooldown() return false end
		else   
			local car_arr = {'being', 'mega_heavy', 'heavy', 'medium', 'light', 'coke_light', 'very_heavy', 'explosives'}
			for i, name in ipairs(car_arr) do
				tweak_data.carry.types[name].can_run = false
				tweak_data.carry.types.being.move_speed_modifier = 0.5
				tweak_data.carry.types.being.jump_modifier = 0.5
				tweak_data.carry.types.being.throw_distance_multiplier = 0.5
				tweak_data.carry.types.mega_heavy.move_speed_modifier = 0.25
				tweak_data.carry.types.mega_heavy.jump_modifier = 0.25
				tweak_data.carry.types.mega_heavy.throw_distance_multiplier = 0.125
				tweak_data.carry.types.very_heavy.move_speed_modifier = 0.25
				tweak_data.carry.types.very_heavy.jump_modifier = 0.25
				tweak_data.carry.types.very_heavy.throw_distance_multiplier = 0.3
				tweak_data.carry.types.heavy.move_speed_modifier = 0.5
				tweak_data.carry.types.heavy.jump_modifier = 0.5
				tweak_data.carry.types.heavy.throw_distance_multiplier = 0.5
				tweak_data.carry.types.medium.move_speed_modifier = 0.75
				tweak_data.carry.types.medium.jump_modifier = 1
				tweak_data.carry.types.medium.throw_distance_multiplier = 1
				tweak_data.carry.types.light.move_speed_modifier = 1
				tweak_data.carry.types.light.jump_modifier = 1
				tweak_data.carry.types.light.can_run = true
				tweak_data.carry.types.light.throw_distance_multiplier = 1
				tweak_data.carry.types.coke_light.move_speed_modifier = tweak_data.carry.types.light.move_speed_modifier
				tweak_data.carry.types.coke_light.jump_modifier = tweak_data.carry.types.light.jump_modifier
				tweak_data.carry.types.coke_light.can_run = tweak_data.carry.types.light.can_run
				tweak_data.carry.types.coke_light.throw_distance_multiplier = tweak_data.carry.types.light.throw_distance_multiplier
				tweak_data.carry.types.explosives.can_explode = true
			end
			ChatMessage('Disabled', 'BAG MOD')
		end 
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- AUTO DRILL SERVICE
	local function drillservice()
		Toggle.drill_auto_service = not Toggle.drill_auto_service
			
		if not Toggle.drill_auto_service then
			backuper:restore('Drill.set_jammed')
			ChatMessage('Disabled', 'AUTO DRILL SERVICE')
			return
		end
		
		ChatMessage('Enabled', 'AUTO DRILL SERVICE')
		backuper:hijack('Drill.set_jammed', function(o, self, jammed, ...)
			local r = o(self, jammed, ...)
			local player = managers.player:local_player()
			if alive(player) and alive(self._unit) and (self._unit.interaction and self._unit:interaction()) and (self._unit:interaction().interact) then
				self._unit:interaction():interact(player)
			end
			return r
		end)
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- INFINTE ECM BATTERY
	local function inf_ecm()
		Toggle.inf_battery_activated = not Toggle.inf_battery_activated
			
		if not Toggle.inf_battery_activated then
			backuper:restore('ECMJammerBase.update')
			ChatMessage('Disabled', 'INFINITE ECM BATTERY')
			return
		end
		
		backuper:backup('ECMJammerBase.update')
		function ECMJammerBase:update( unit, t, dt )
			self._battery_life = self._max_battery_life
		end
		ChatMessage('Enabled', 'INFINITE ECM BATTERY')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------				
	-- INFINITE SPECIALS
	local function InfiniteSpecial()
		backuper:backup('PlayerManager.remove_special')

		Toggle.infinite_special = not Toggle.infinite_special
			
		if not Toggle.infinite_special then
			backuper:restore('PlayerManager.remove_special')
			ChatMessage('Disabled', 'INFINITE SPECIALS')
			return
		end

		function PlayerManager:remove_special(name) end
		ChatMessage('Enabled', 'INFINITE SPECIALS')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INFINITE MESSIAH CHARGES
	local function infmessiah()
		Toggle.consume_messiah_charg = not Toggle.consume_messiah_charg
			
		if not Toggle.consume_messiah_charg then
			backuper:restore('PlayerDamage.consume_messiah_charge')
			ChatMessage('Disabled', 'INFINITE MESSIAH CHARGES')
			return
		end
		
		backuper:backup('PlayerDamage.consume_messiah_charge')
		function PlayerDamage:consume_messiah_charge() return true end	
		ChatMessage('Enabled', 'INFINITE MESSIAH CHARGES')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INFINITE DOCTOR BAG USES
	local function infdocbag()
		Toggle.infdoc = not Toggle.infdoc
			
		if not Toggle.infdoc then
			backuper:restore('DoctorBagBase._take')
			ChatMessage('Disabled', 'INFINITE DOCTOR BAG USES')
			return
		end
		
		backuper:backup('DoctorBagBase._take')
		function DoctorBagBase:_take(unit)
			unit:character_damage():recover_health() -- replenish()
			return 0
		end	
		ChatMessage('Enabled', 'INFINITE DOCTOR BAG USES')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INFINITE AMMO BAG USES
	local function infammobag()
		Toggle.takeammo = not Toggle.takeammo
			
		if not Toggle.takeammo then
			backuper:restore('AmmoBagBase._take_ammo')
			ChatMessage('Disabled', 'INFINITE AMMO BAG USES')
			return
		end
	
		backuper:backup('AmmoBagBase._take_ammo')
		function AmmoBagBase:_take_ammo(unit)
			local inventory = unit:inventory()
			if inventory then
				for _,weapon in pairs( inventory:available_selections() ) do
					local took = weapon.unit:base():add_ammo_from_bag( self._ammo_amount )
				end	
			end	
			return 0
		end	
		ChatMessage('Enabled', 'INFINITE AMMO BAG USES')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- ALLOW INFINITE PAGERS
	local function inf_pager_answers()
		Toggle.inf_pager_answers = not Toggle.inf_pager_answers
			
		if not Toggle.inf_pager_answers then
			backuper:restore('GroupAIStateBase.on_successful_alarm_pager_bluff')
			ChatMessage('Disabled', 'INFINITE PAGERS')
			return
		end
		
		backuper:backup('GroupAIStateBase.on_successful_alarm_pager_bluff')
		function GroupAIStateBase:on_successful_alarm_pager_bluff()	end
		ChatMessage('Enabled', 'INFINITE PAGERS')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- INFINTE CONVERTS
	function inf_converts()
		Toggle.inf_converts = not Toggle.inf_converts
			
		if not Toggle.inf_converts then
			tweak_data.upgrades.values.player.convert_enemies_max_minions = {1,2}
			ChatMessage('Disabled', 'INFINITE CONVERTS')
			return
		end
				
		tweak_data.upgrades.values.player.convert_enemies = {true}
		tweak_data.upgrades.values.player.convert_enemies_max_minions = {999999,999999}
		ChatMessage('Enabled', 'INFINITE CONVERTS')
	end 
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- CARRYSTACKER
	local function carrystack()
		local _debugEnabled = false
		local BagIcon = "pd2_loot"
		
		Toggle.toggle_Carry = not Toggle.toggle_Carry

		if Toggle.toggle_Carry then
			ChatMessage('Enabled', 'CARRYSTACKER')
			if managers and managers.player and IntimitateInteractionExt and CarryInteractionExt then
				managers.player.carry_stack = {}
				managers.player.carrystack_lastpress = 0
				managers.player.drop_all_bags = false
				local ofuncs = {
				  managers_player_set_carry = managers.player.set_carry,
				  managers_player_drop_carry = PlayerManager.drop_carry,
				  IntimitateInteractionExt__interact_blocked = IntimitateInteractionExt._interact_blocked,
				  CarryInteractionExt__interact_blocked = CarryInteractionExt._interact_blocked,
				  CarryInteractionExt_can_select = CarryInteractionExt.can_select,
				}
				
				function managers.player:refresh_stack_counter()
					local count = #self.carry_stack + (self:is_carrying() and 1 or 0)
					managers.hud:remove_special_equipment("carrystacker")
					if count > 0 then
						managers.hud:add_special_equipment({id = "carrystacker", icon = BagIcon, amount = count})
					end	
				end
			
				function managers.player:rotate_stack(dir)
					if #managers.player.carry_stack < 1 or (#managers.player.carry_stack < 2 and not self:is_carrying()) then
						return
					end
					if self:is_carrying() then
						table.insert(self.carry_stack, self:get_my_carry_data())
					end
					if dir == "up" then
						table.insert(self.carry_stack, 1, table.remove(self.carry_stack))
					else
						table.insert(self.carry_stack, table.remove(self.carry_stack, 1))
					end
					local cdata = table.remove(self.carry_stack)
					if cdata then
						if self:is_carrying() then self:carry_discard() end
						ofuncs.managers_player_set_carry(self, cdata.carry_id, cdata.multiplier, cdata.dye_initiated, cdata.has_dye_pack, cdata.dye_value_multiplier, cdata.zipline_unit)
					end	
				end
				
				-- POPS AN ITEM FROM THE STACK WHEN THE PLAYER DROPS THEIR CARRIED ITEM
				function managers.player:drop_carry(zipline_unit) 
					ofuncs.managers_player_drop_carry(self, zipline_unit)
					if #self.carry_stack > 0 then
						local cdata = table.remove(self.carry_stack)
						if cdata then
							self:set_carry(cdata.carry_id, cdata.multiplier or 1, cdata.dye_initiated, cdata.has_dye_pack, cdata.dye_value_multiplier, cdata.zipline_unit)
						end	
					end
					self:refresh_stack_counter()
					if self.drop_all_bags then
						if #self.carry_stack > 0 or self:is_carrying() then
							self:drop_carry()
						end
						self.drop_all_bags = false
					end
					-- IF CARRYSTACKER IS OFF, THEN DROP ALL BUT ONE BAG IF THIS IS RUN
					if not Toggle.toggle_Carry then
						if #self.carry_stack > 0 then
							self:drop_carry()
						end	
					end
				end
					
				-- SAVES THE CURRENT ITEM TO THE STACK IF WE'RE ALREADY CARRYING SOMETHING
				function managers.player:set_carry(carry_id, carry_multiplier, dye_initiated, has_dye_pack, dye_value_multiplier, zipline_unit)
					if self:is_carrying() and self:get_my_carry_data() then
						table.insert(self.carry_stack, self:get_my_carry_data())
					end
					ofuncs.managers_player_set_carry(self, carry_id, carry_multiplier, dye_initiated, has_dye_pack, dye_value_multiplier, zipline_unit)
					self:refresh_stack_counter()
				end

				-- NEW FUNCTION TO DISCARD THE CURRENTLY CARRIED ITEM
				function managers.player:carry_discard()
					managers.hud:remove_teammate_carry_info( HUDManager.PLAYER_PANEL )
					managers.hud:temp_hide_carry_bag()
					self:update_removed_synced_carry_to_peers()
					if self._current_state == "carry" then
						managers.player:set_player_state( "standard" )
					end	
				end
				
				-- OVERRIDDEN TO PREVENT BLOCKING US FROM PICKING UP A DEAD BODY
				function IntimitateInteractionExt:_interact_blocked( player )
					if Toggle.toggle_Carry and self.tweak_data == "corpse_dispose" then
						if not managers.player:has_category_upgrade( "player", "corpse_dispose" ) then
							return true
						end
						return not managers.player:can_carry( "person" )
					end
					-- RUN THE ORIGINAL FUNCTION IF CARRYSTACKER IS OFF OR IF PLAYER ISN'T DISPOSING OF A CORPSE
					return ofuncs.IntimitateInteractionExt__interact_blocked(self, player)
				end

				-- OVERRIDDEN TO ALWAYS ALLOW US TO PICK UP A CARRY ITEM
				function CarryInteractionExt:_interact_blocked( player )
					if Toggle.toggle_Carry then
						return not managers.player:can_carry( self._unit:carry_data():carry_id() )
					end
					-- RUN THE ORIGINAL FUNCTION IF CARRYSTACKER IS OFF
					return ofuncs.CarryInteractionExt__interact_blocked(self, player)
				end

				-- OVERRIDDEN TO ALWAYS ALLOW US TO SELECT A CARRY ITEM
				function CarryInteractionExt:can_select( player )
					if Toggle.toggle_Carry then
						return CarryInteractionExt.super.can_select( self, player )
					end
					-- RUN THE ORIGINAL FUNCTION IF CARRYSTACKER IS OFF
					return ofuncs.CarryInteractionExt_can_select(self, player)
				end

				-- CUSTOM FUNCTION. PUSHES A CARRIED ITEM TO STACK AND DISCARDS IT OR POPS ONE IF WE'RE NOT CARRYING ANYTHING.
				-- THIS FUNCTION IS CALLED EVERY TIME THE SCRIPT GETS RUN.
				function managers.player:carry_stacker()
					if _debugEnabled then
						io.stderr:write("current stack size: ".. tostring(#managers.player.carry_stack) .. "\n")
						if #managers.player.carry_stack > 0 then
							for _,v in pffairs(managers.player.carry_stack) do
								io.stderr:write("item: ".. v.carry_id .. "\n")
							end	
						end	
					end
				
					local cdata = self:get_my_carry_data()
					if self:is_carrying() and cdata then
						table.insert(self.carry_stack, self:get_my_carry_data())
						self:carry_discard()
						managers.hud:present_mid_text( { title = "Carry Stack", text = cdata.carry_id .. " Pushed", time = 1 } )
					elseif #self.carry_stack > 0 then
						cdata = table.remove(self.carry_stack)
						self:set_carry(cdata.carry_id, cdata.multiplier, cdata.dye_initiated, cdata.has_dye_pack, cdata.dye_value_multiplier, cdata.zipline_unit)
						managers.hud:present_mid_text( { title = "Carry Stack", text = cdata.carry_id .. " Popped", time = 1 } )
					else
						managers.hud:present_mid_text( { title = "Carry Stack", text = "Empty", time = 1 } )
					end
					
					if (Application:time() - self.carrystack_lastpress) < 0.3 and (self:is_carrying() or #self.carry_stack > 0) then
						self.drop_all_bags = true
						self:drop_carry()
					end
					self.carrystack_lastpress = Application:time()
					self:refresh_stack_counter()
				end	
			end
		else
			ChatMessage('Disabled', 'CARRYSTACKER') 
			if managers.player:is_carrying() then
				managers.player:drop_carry()
			end
		end 
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- CARRY LIMITS
	local function carrylimit()
		local carry_limits = {
		-- modifer_power 	--> How much additional bags affect on this modifier (bigger - slower)
		-- min_val			--> Minimal value of that modifier
		move_speed_modifier	=	{	modifer_power = 0.35,	min_val = 0.15	},
		jump_modifier		=	{	modifer_power = 0.2,	min_val = 0.35	},		
		}
		
		Toggle.carr_limit = not Toggle.carr_limit
		
		if not Toggle.carr_limit then
			backuper:restore('PlayerCarry._get_max_walk_speed')
			backuper:restore('PlayerCarry._get_walk_headbob')
			backuper:restore('PlayerCarry._perform_jump')
			backuper:restore('PlayerCarry._check_action_run')
			tweak_data.carry.types.light.move_speed_modifier = 1.0
			tweak_data.carry.types.coke_light.move_speed_modifier = tweak_data.carry.types.coke_light.move_speed_modifier
			ChatMessage('Disabled', 'CARRY LIMIT')
			return
		end
		
		function append_carry_limits(in_value, modifer_type)
			local out_value = in_value
				
			if managers.player.carry_stack ~= nil and #managers.player.carry_stack > 0 then
				for _,v in pairs(managers.player.carry_stack) do
					if type(v) == "table" then
						if tweak_data.carry[v.carry_id] ~= nil then
							local carry_type = tweak_data.carry[v.carry_id].type

							if tweak_data.carry.types[carry_type] ~= nil then
								local add_mul = (1 - tweak_data.carry.types[carry_type][modifer_type]) * carry_limits[modifer_type].modifer_power
								if add_mul < 0 then add_mul = 0 end							
								out_value = out_value - add_mul
								if out_value < 0 then out_value = carry_limits[modifer_type].min_val end	
								if out_value > 1 then out_value = 1 end
							end	
						end	
					end	
				end	
			end		
			return out_value
		end
		tweak_data.carry.types.light.move_speed_modifier = 0.9	-- 1.0 in orig game (Diamonds and jewelry)
		tweak_data.carry.types.coke_light.move_speed_modifier = 0.9	-- types.light

		-- Walk Speed
		backuper:backup('PlayerCarry._get_max_walk_speed')
		function PlayerCarry:_get_max_walk_speed(...)
			local multiplier = tweak_data.carry.types[self._tweak_data_name].move_speed_modifier		
			if managers.player:has_category_upgrade("carry", "movement_penalty_nullifier") then
				multiplier = 1
			else
				multiplier = append_carry_limits(multiplier, "move_speed_modifier")	-- new
				multiplier = math.clamp(multiplier * managers.player:upgrade_value("carry", "movement_speed_multiplier", 1), 0, 1)
			end	
			return PlayerCarry.super._get_max_walk_speed(self, ...) * multiplier	
		end	
			
		-- Bobbing effect
		backuper:backup('PlayerCarry._get_walk_headbob')
		function PlayerCarry:_get_walk_headbob(...)
			local multiplier = append_carry_limits(tweak_data.carry.types[self._tweak_data_name].move_speed_modifier, "move_speed_modifier")	
			--new
			return PlayerCarry.super._get_walk_headbob(self, ...) * multiplier
		end	

		-- Jump power
		backuper:backup('PlayerCarry._perform_jump')
		function PlayerCarry:_perform_jump(jump_vec)
			if managers.player:has_category_upgrade("carry", "movement_penalty_nullifier") then
			else
				local multiplier = append_carry_limits(tweak_data.carry.types[self._tweak_data_name].jump_modifier, "jump_modifier")	-- new
				mvector3.multiply(jump_vec, multiplier)
			end
			PlayerCarry.super._perform_jump(self, jump_vec)
		end	
				
		-- Can Run
		backuper:backup('PlayerCarry._check_action_run')
		function PlayerCarry:_check_action_run(...)	-- new
			local bCanRun = tweak_data.carry.types[self._tweak_data_name].can_run	
			if bCanRun == true then
				if managers.player.carry_stack ~= nil and #managers.player.carry_stack > 0 then
					for _,v in pairs(managers.player.carry_stack) do
						if type(v) == "table" then
							if tweak_data.carry[v.carry_id] ~= nil then
								local carry_type = tweak_data.carry[v.carry_id].type
								if tweak_data.carry.types[carry_type] ~= nil then
									if tweak_data.carry.types[carry_type].can_run == false then
										bCanRun = false
										break
									end	
								end	
							end	
						end	
					end	
				end	
			end			
			if bCanRun or managers.player:has_category_upgrade("carry", "movement_penalty_nullifier") then
				PlayerCarry.super._check_action_run(self, ...)
			end	
		end
		ChatMessage('Enabled', 'CARRY LIMIT')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- CARRY CROSSHAIR MOD
	local function carrycross()
		Toggle.carry_cross = not Toggle.carry_cross
		
		if not Toggle.carry_cross then
			backuper:restore('PlayerManager.drop_carry')
			ChatMessage('Disabled', 'CARRY CROSSHAIR MOD')
			return
		end
		
		backuper:backup('PlayerManager.drop_carry')
		function PlayerManager:drop_carry(zipline_unit)
			local carry_data = self:get_my_carry_data()
			local camera_ext = managers.player:player_unit():camera()
			local position = get_crosshair_pos()
			local dye_initiated = carry_data.dye_initiated
			local has_dye_pack = carry_data.has_dye_pack
			local dye_value_multiplier = carry_data.dye_value_multiplier
			local throw_distance_multiplier_upgrade_level = managers.player:upgrade_level("carry", "throw_distance_multiplier", 0)
			if Network:is_client() then
				if position then
					managers.network:session():send_to_host("server_drop_carry", carry_data.carry_id, carry_data.multiplier, dye_initiated, has_dye_pack, dye_value_multiplier, position, camera_ext:rotation(), managers.player:player_unit():camera():forward(), throw_distance_multiplier_upgrade_level, zipline_unit)
				else
					managers.network:session():send_to_host("server_drop_carry", carry_data.carry_id, carry_data.multiplier, dye_initiated, has_dye_pack, dye_value_multiplier, camera_ext:position(), camera_ext:rotation(),managers.player:player_unit():camera():forward(), throw_distance_multiplier_upgrade_level, zipline_unit)
				end
			else
				if position then
					self:server_drop_carry(carry_data.carry_id, carry_data.multiplier, dye_initiated, has_dye_pack, dye_value_multiplier, position, camera_ext:rotation(), managers.player:player_unit():camera():forward(), throw_distance_multiplier_upgrade_level, zipline_unit, managers.network:session():local_peer():id())
				else	
					self:server_drop_carry(carry_data.carry_id, carry_data.multiplier, dye_initiated, has_dye_pack, dye_value_multiplier, camera_ext:position(), camera_ext:rotation(), managers.player:player_unit():camera():forward(), throw_distance_multiplier_upgrade_level, zipline_unit, managers.network:session():local_peer():id())
				end	
			end
			managers.hud:remove_teammate_carry_info(HUDManager.PLAYER_PANEL)
			managers.hud:temp_hide_carry_bag()
			self:update_removed_synced_carry_to_peers()
			if self._current_state == "carry" then
				managers.player:set_player_state("standard")
			end
		end
		ChatMessage('Enabled', 'CARRY CROSSHAIR MOD')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	-- ENABLE FRIENDLY FIRE
	local function friendfire()
		Toggle.friendly_fire = not Toggle.friendly_fire
		
		if not Toggle.friendly_fire then
			backuper:restore('PlayerDamage.is_friendly_fire')
			ChatMessage('Disabled', 'FRIENDLYFIRE')
			return 
		end
		
		backuper:backup('PlayerDamage.is_friendly_fire')
		function PlayerDamage:is_friendly_fire(unit)
			return false
		end
		ChatMessage('Enabled', 'FRIENDLYFIRE')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- ZIPLINE BAGS 
	local function ZiplineBag()	
		Toggle.Zipline_Bags = not Toggle.Zipline_Bags

		if not Toggle.Zipline_Bags then
			backuper:restore('ZipLine.on_interacted')
			ChatMessage('Disabled', 'ZIPLINETRANSPORT')
			return
		end

		local on_interacted_original = backuper:backup('ZipLine.on_interacted')
		function ZipLine:on_interacted(unit)
			if self:is_usage_type_person() then
				if managers.player:is_carrying() then
					if Network:is_server() then
						managers.player:drop_carry(self._unit)
					else
						self:_client_request_attach_bag(unit)
					end
					return
				end
				if Network:is_server() then
					if not alive(self._user_unit) then
						self:set_user(unit)
					end
				else
					self:_client_request_access(unit)
				end
			end
			on_interacted_original(self, unit)
		end
		ChatMessage('Enabled', 'ZIPLINETRANSPORT')
	end
-----------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
	PlayerMenu = CustomMenuClass:new()
	PlayerMenu:addMainMenu('main_menu', {title = 'Player Menu - Select Toggle', maxRows = 12})
	
	-- PLAYER MENU COLUMN 1
	PlayerMenu:addInformationOption('main_menu', 'QUICK PLAYER TOGGLES', {textColor = Color.DodgerBlue})
	if MVPConfig.Player_Menu_Config and MVPConfig.God_Mode then	
		PlayerMenu:addToggleOption('main_menu', 'God Mode', {callback = godmode, help = 'Become Invincible', toggle = true})
	else	
		PlayerMenu:addToggleOption('main_menu', 'God Mode', {callback = godmode, help = 'Become Invincible'})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Friendly_Fire then	
		PlayerMenu:addToggleOption('main_menu', 'Friendly Fire', {callback = friendfire, help = 'Enable Friendly Fire', toggle = true})
	else
		PlayerMenu:addToggleOption('main_menu', 'Friendly Fire', {callback = friendfire, help = 'Enable Friendly Fire'})
	end
	PlayerMenu:addGap('main_menu')
	PlayerMenu:addInformationOption('main_menu', 'PLAYER TOGGLES', {textColor = Color.DodgerBlue})
	if MVPConfig.Player_Menu_Config and MVPConfig.Auto_Drill_Service then
		PlayerMenu:addToggleOption('main_menu', 'Auto Drill Service', {callback = drillservice, help = 'Auto Restores Drill(s) When Jammed', toggle = true})
	else	
		PlayerMenu:addToggleOption('main_menu', 'Auto Drill Service', {callback = drillservice, help = 'Auto Restores Drill(s) When Jammed'})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Carry_Mod then
		PlayerMenu:addToggleOption('main_menu', 'Carry Mod', {callback = carrymod, toggle = true, help = 'Removes Weight Of All Bags And Explosive Property Of Ammo Bag'})
	else
		PlayerMenu:addToggleOption('main_menu', 'Carry Mod', {callback = carrymod, help = 'Removes Weight Of All Bags And Explosive Property Of Ammo Bag'})
	end
	PlayerMenu:addToggleOption('main_menu', 'Carry Crosshair Mod', {callback = carrycross, help = 'Spawns Carrying Bag On Crosshair, Enable This First If You Want To Use With CarryStacker '})
	if MVPConfig.Player_Menu_Config and MVPConfig.Cloakers_Cuff_Self then
		PlayerMenu:addToggleOption('main_menu', 'Cloakers Only Cuff Self', {callback = spooccuffselfon, help = 'Cloakers Will Only Cuff Themselves', toggle = true})
	else
		PlayerMenu:addToggleOption('main_menu', 'Cloakers Only Cuff Self', {callback = spooccuffselfon, help = 'Cloakers Will Only Cuff Themselves'})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Infinite_Ammo then	
		PlayerMenu:addToggleOption('main_menu', 'Infinite Ammo', {callback = infammo, toggle = true})
	else
		PlayerMenu:addToggleOption('main_menu', 'Infinite Ammo', {callback = infammo})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Infinite_Ammo_Bag then
		PlayerMenu:addToggleOption('main_menu', 'Infinite Ammo Bag Uses', {callback = infammobag, toggle = true})
	else
		PlayerMenu:addToggleOption('main_menu', 'Infinite Ammo Bag Uses', {callback = infammobag})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Infinite_Specials then
		PlayerMenu:addToggleOption('main_menu', 'Infinite Specials', {callback = InfiniteSpecial, help = "Infinite Specials Such As Cable-Ties, Planks, Etc.", toggle = true})
	else
		PlayerMenu:addToggleOption('main_menu', 'Infinite Specials', {callback = InfiniteSpecial, help = "Infinite Specials Such As Cable-Ties, Planks, Etc."})
	end
	
	-- PLAYER MENU COLUMN 2
	PlayerMenu:addGap('main_menu')
	if MVPConfig.Player_Menu_Config and MVPConfig.Carry_Stacker then
		PlayerMenu:addToggleOption('main_menu', 'Carry Stacker', {callback = carrystack, toggle = true, help = 'Will Mark You As Cheater If Not Host'})
	else
		PlayerMenu:addToggleOption('main_menu', 'Carry Stacker', {callback = carrystack, help = 'Will Mark You As Cheater If Not Host'})
	end
	PlayerMenu:addToggleOption('main_menu', 'Carry Stacker Weight Limit', {callback = carrylimit, help = 'Weight Modifier For CarryStacker, The More Bags You Carry The Heavier Your Weight'})
	PlayerMenu:addGap('main_menu')
	PlayerMenu:addGap('main_menu')

	if isHost() then
		if MVPConfig.Player_Menu_Config and MVPConfig.Infinite_Converts then
			PlayerMenu:addToggleOption('main_menu', 'Infinite Converts', {callback = inf_converts, toggle = true})
		else	
			PlayerMenu:addToggleOption('main_menu', 'Infinite Converts', {callback = inf_converts})
		end
	else
		PlayerMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Infinite_Doc_Bag_Use then
		PlayerMenu:addToggleOption('main_menu', 'Infinite Doctor Bag Uses', {callback = infdocbag, toggle = true})
	else
		PlayerMenu:addToggleOption('main_menu', 'Infinite Doctor Bag Uses', {callback = infdocbag})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Infinite_ECM_Battery then	
		PlayerMenu:addToggleOption('main_menu', 'Infinite ECM Battery', {callback = inf_ecm, toggle = true})
	else	
		PlayerMenu:addToggleOption('main_menu', 'Infinite ECM Battery', {callback = inf_ecm})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Infinite_Messiah_Charge then	
		PlayerMenu:addToggleOption('main_menu', 'Infinite Messiah Charges', {callback = infmessiah, toggle = true})	
	else
		PlayerMenu:addToggleOption('main_menu', 'Infinite Messiah Charges', {callback = infmessiah})
	end
	if isHost() then
		if MVPConfig.Player_Menu_Config and MVPConfig.Infinite_Pager_Answers then	
			PlayerMenu:addToggleOption('main_menu', 'Infinite Pager Answers', {callback = inf_pager_answers, toggle = true})
		else
			PlayerMenu:addToggleOption('main_menu', 'Infinite Pager Answers', {callback = inf_pager_answers})
		end
		if MVPConfig.Player_Menu_Config and MVPConfig.Instant_Dominate then
			PlayerMenu:addToggleOption('main_menu', 'Instant Dominate', {callback = instantdom, toggle = true})
		else	
			PlayerMenu:addToggleOption('main_menu', 'Instant Dominate', {callback = instantdom})
		end
	else
		PlayerMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		PlayerMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	if isHost() then
		if MVPConfig.Player_Menu_Config and MVPConfig.Instant_Drill then	
			PlayerMenu:addToggleOption('main_menu', 'Instant Drill/Computer', {callback = instantdrill, help = 'Can Be Activated After Drill(s) Has Been Placed Or Computer Has Been Activated', toggle = true})
		else	
			PlayerMenu:addToggleOption('main_menu', 'Instant Drill/Computer', {callback = instantdrill, help = 'Can Be Activated After Drill(s) Has Been Placed Or Computer Has Been Activated'})
		end
	else
		PlayerMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow })
	end
	
	-- PLAYER MENU COLUMN 3
	PlayerMenu:addGap('main_menu')
	if MVPConfig.Player_Menu_Config and MVPConfig.Instant_Interact then	
		PlayerMenu:addToggleOption('main_menu', 'Instant Interact', {callback = instantinteract, help = 'Includes Instant Pager Answers', toggle = true})
	else	
		PlayerMenu:addToggleOption('main_menu', 'Instant Interact', {callback = instantinteract, help = 'Includes Instant Pager Answers'})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Instant_Interact_With_Anything then
		PlayerMenu:addToggleOption('main_menu', 'Interact With Anything', {callback = interactanyhting, toggle = true})
	else	
		PlayerMenu:addToggleOption('main_menu', 'Interact With Anything', {callback = interactanyhting})
	end
	PlayerMenu:addGap('main_menu')
	PlayerMenu:addGap('main_menu')
	if MVPConfig.Player_Menu_Config and MVPConfig.Interact_Distance_Increase then		
		PlayerMenu:addToggleOption('main_menu', 'Interact Distance Increase', {callback = intdist, toggle = true})
	else	
		PlayerMenu:addToggleOption('main_menu', 'Interact Distance Increase', {callback = intdist})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Interact_Look_Around then	
		PlayerMenu:addToggleOption('main_menu', 'Interact Look-Around', {callback = interactlook, toggle = true})
	else	
		PlayerMenu:addToggleOption('main_menu', 'Interact Look-Around', {callback = interactlook})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Interact_Thru_Wall then	
		PlayerMenu:addToggleOption('main_menu', 'Interact Thru Wall', {callback = interactwall, toggle = true})
	else	
		PlayerMenu:addToggleOption('main_menu', 'Interact Thru Wall', {callback = interactwall})
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.No_Hit_Disorientation then	
		PlayerMenu:addToggleOption('main_menu', 'No Hit Disorientation', {callback = nohitdis, toggle = true})
	else
		PlayerMenu:addToggleOption('main_menu', 'No Hit Disorientation', {callback = nohitdis})
	end
	if isHost() then
		if MVPConfig.Player_Menu_Config and MVPConfig.Small_Loot_Multiplier then	
			PlayerMenu:addToggleOption('main_menu', 'Small Loot Multiplier', {callback = smlootmulti, help = 'Muliplied by 3x, Loot Capped at $2,800,000', toggle = true})
		else	
			PlayerMenu:addToggleOption('main_menu', 'Small Loot Multiplier', {callback = smlootmulti, help = 'Muliplied by 3x, Loot Capped at $2,800,000'})
		end
	else
		PlayerMenu:addInformationOption('main_menu', 'Not Available (Host Only)', { textColor = Color.yellow })
	end
	if MVPConfig.Player_Menu_Config and MVPConfig.Zipline_Transport then
		PlayerMenu:addToggleOption('main_menu', 'Zipline Transport', {callback = ZiplineBag, help = 'Allows You To Transport Bags On All Ziplines', toggle = true})
	else
		PlayerMenu:addToggleOption('main_menu', 'Zipline Transport', {callback = ZiplineBag, help = 'Allows You To Transport Bags On All Ziplines'})
	end
end
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
if inGame() and isPlaying() then
    if PlayerMenu:isOpen() then
        PlayerMenu:close()
    else
	    if ChangerMenu then
			if ChangerMenu:isOpen() then
				ChangerMenu:close()
			end	
		end
		if StealthMenu then
			if StealthMenu:isOpen() then
				StealthMenu:close()
			end	
		end
		if MissionMenu then
			if MissionMenu:isOpen() then
				MissionMenu:close()
			end	
		end
		if InventoryMenu then
			if InventoryMenu:isOpen() then
				InventoryMenu:close()
			end	
		end
		if MoneyMenu then
			if MoneyMenu:isOpen() then
				MoneyMenu:close()
			end	
		end
		if NumpadMenu then
			if NumpadMenu:isOpen() then
				NumpadMenu:close()
			end	
		end
		if InteractTimerMenu then	
			if InteractTimerMenu:isOpen() then
				InteractTimerMenu:close()
			end	
		end	
		PlayerMenu:open()
	end 
end 