---------------------
---- FUNCTIONS ------
---------------------
if not StealthMenu then
	-- UNLOCK MESSIAH CHARGES SKILL
	local function unlmessiah()		
		Toggle.got_messiah_charges = not Toggle.got_messiah_charges

		if not Toggle.got_messiah_charges then
			backuper:restore("PlayerDamage.got_messiah_charges")
			ChatMessage('Disabled', 'UNLOCK MESSIAH CHARGES')
			return
		end
		
		backuper:backup("PlayerDamage.got_messiah_charges")
		function PlayerDamage:got_messiah_charges() return true end	
		ChatMessage('Enabled', 'UNLOCK MESSIAH CHARGES')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- REMOTE CAMERA ACCESS
	function remote_camera()
		game_state_machine:change_state_by_name("ingame_access_camera")
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- COPS DONT SHOOT
	local function cops_dont_shoot()			
		Toggle.copsdontshoot = not Toggle.copsdontshoot

		if not Toggle.copsdontshoot then
			backuper:restore('CopMovement.set_allow_fire')
			backuper:restore('CopMovement.set_allow_fire_on_client')
			ChatMessage('Disabled', 'COPS DONT SHOOT')
			return
		end
		
		local _setAllowFire = backuper:backup('CopMovement.set_allow_fire')
		function CopMovement:set_allow_fire(state)
			if state == false then 
				_setAllowFire(self, state) 
			end
		end
		
		local _setAllowFireClient = backuper:backup('CopMovement.set_allow_fire_on_client')
		function CopMovement:set_allow_fire_on_client(state, unit)
			if state == false then 
				_setAllowFireClient(self, state, unit) 
			end
		end
		ChatMessage('Enabled', 'COPS DONT SHOOT')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- NO CALL POLICE
	local function people_dont_call_police()		
		Toggle.dont_call_police = not Toggle.dont_call_police

		if not Toggle.dont_call_police then
			backuper:restore('GroupAIStateBase.on_police_called')
			backuper:restore('CivilianLogicFlee.clbk_chk_call_the_police')
			ChatMessage('Disabled', 'NO POLICE CALLS')
			return
		end

		backuper:backup('GroupAIStateBase.on_police_called')
		function GroupAIStateBase:on_police_called(called_reason) end
		
		backuper:backup('CivilianLogicFlee.clbk_chk_call_the_police')
		function CivilianLogicFlee.clbk_chk_call_the_police(ignore_this, data) end
		ChatMessage('Enabled', 'NO POLICE CALLS')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- NO PANIC BUTTON
	local function prevent_panic_buttons()	
		Toggle.preventpanicbuttons = not Toggle.preventpanicbuttons

		if not Toggle.preventpanicbuttons then 
			backuper:restore('CopMovement.action_request')
			ChatMessage('Disabled', 'NO PANIC BUTTON/INTEL BURN')
			return
		end

		local _actionRequest = backuper:backup('CopMovement.action_request')
		function CopMovement:action_request(action_desc)
			if action_desc.variant == "run" or action_desc.variant == "e_so_alarm_under_table" or action_desc.variant == "cmf_so_press_alarm_wall" 
			or action_desc.variant == "cmf_so_press_alarm_table" or action_desc.variant == "cmf_so_call_police" or action_desc.variant == "arrest_call" then 
				return false 
			end
			return _actionRequest(self, action_desc)
		end
		ChatMessage('Enabled', 'NO PANIC BUTTON/INTEL BURN')	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- NO CASH PENALTY FOR KILLING CIVILLIANS
	local function free_kill()		
		Toggle.free_kill = not Toggle.free_kill
		
		-- DISABLE FREE KILL
		if not Toggle.free_kill then
			backuper:restore('MoneyManager.get_civilian_deduction')
			backuper:restore('MoneyManager.civilian_killed')
			backuper:restore('UnitNetworkHandler.sync_hostage_killed_warning')
			ChatMessage('Disabled', 'FREE CIVILIAN KILLS')
			return
		end

		-- ENABLE FREE KILL
		backuper:backup('MoneyManager.get_civilian_deduction')
		function MoneyManager.get_civilian_deduction() return 0 end
		
		backuper:backup('MoneyManager.civilian_killed')
		function MoneyManager.civilian_killed() return end
		
		backuper:backup('UnitNetworkHandler.sync_hostage_killed_warning')
		function UnitNetworkHandler:sync_hostage_killed_warning(warning) return 0 end	
		ChatMessage('Enabled', 'FREE CIVILIAN KILLS')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- DISABLE CAMS 
	function disable_cams()
		Toggle.disablecams = not Toggle.disablecams
	
		if not Toggle.disablecams then
			for _,unit in pairs(GroupAIStateBase._security_cameras) do
				unit:base():set_update_enabled(true)
			end	
			ChatMessage('Disabled', 'DISABLE CAMS')
			return
		end
			
		-- DISABLE CAMS
		for _,unit in pairs(GroupAIStateBase._security_cameras) do
			unit:base():set_update_enabled(false)
		end
		ChatMessage('Enabled', 'DISABLE CAMS')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- PAGERS DISABLE
	local function disable_pagers()		
		Toggle.disablepagers = not Toggle.disablepagers
			
		-- ENABLE PAGERS
		if not Toggle.disablepagers then
			backuper:restore('CopLogicInactive._set_interaction')
			backuper:restore('CopLogicIntimidated._chk_begin_alarm_pager')
			ChatMessage('Disabled', 'DISABLE PAGERS')
			return
		end
		
		-- DISABLE PAGERS
		backuper:backup('CopLogicIntimidated._chk_begin_alarm_pager')
		function CopLogicIntimidated._chk_begin_alarm_pager(data) end

		backuper:backup('CopLogicInactive._set_interaction')
		function CopLogicInactive._set_interaction(data, my_data)
			data.unit:unit_data().has_alarm_pager = false
		end 
		ChatMessage('Enabled', 'DISABLE PAGERS')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- LOBOTOMIZE ALL AI by voodoo
	local function lobai()
		Toggle.lobotomize_ai = not Toggle.lobotomize_ai

		if not Toggle.lobotomize_ai then -- Enable AI
			-- Restore spawn AI function
			backuper:restore('CopBrain.set_spawn_ai')
			ChatMessage('Disabled', 'LOBOTOMIZE AI')
			for u_key, u_data in pairs( managers.enemy:all_enemies() ) do
				u_data.unit:brain():set_active( true )
			end
			for u_key, u_data in pairs( managers.enemy:all_civilians() ) do
				u_data.unit:brain():set_active( true )
			end
			for u_key, unit in pairs( SecurityCamera.cameras ) do
				unit:base()._detection_interval = 0.1
			end
		else -- Disable AI
			ChatMessage('Enabled', 'LOBOTOMIZE AI')
			for u_key, u_data in pairs( managers.enemy:all_enemies() ) do
				u_data.unit:brain():set_active( false )
			end
			for u_key, u_data in pairs( managers.enemy:all_civilians() ) do
				u_data.unit:brain():set_active( false )
			end
			for u_key, unit in pairs( SecurityCamera.cameras ) do
				unit:base():_destroy_all_detected_attention_object_data()
				unit:base():_send_net_event( 1 )
				unit:base()._detection_interval = 1000000
			end
			
			-- Backup spawn AI function
			backuper:backup('CopBrain.set_spawn_ai')
			
			-- Set default spawn AI to inactive
			function CopBrain:set_spawn_ai( spawn_ai )
				spawn_ai.init_state = "inactive"
				self._spawn_ai = spawn_ai
				self:set_update_enabled_state( true )
				self:set_logic( "inactive" )
				if spawn_ai.stance then
					self._unit:movement():set_stance( spawn_ai.stance )
				end
				if spawn_ai.objective then
					self:set_objective( spawn_ai.objective )
				end	
			end
			
			-- BUGFIX: if objective == nil, abort (Do not undo this function)
			function CopBrain:set_followup_objective( followup_objective )
				if not self._logic_data.objective then
					return
				end
				local old_followup = self._logic_data.objective.followup_objective
				self._logic_data.objective.followup_objective = followup_objective
				
				if followup_objective and followup_objective.interaction_voice then
					self._unit:network():send( "set_interaction_voice", followup_objective.interaction_voice )
				elseif old_followup and old_followup.interaction_voice then
					self._unit:network():send( "set_interaction_voice", "" )
				end	
			end	
		end	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- STEAL PAGERS By Harfatus
	local function steal_pagers_on_melee() 				
		Toggle.steal_pagers = not Toggle.steal_pagers
		
		if not Toggle.steal_pagers then
			backuper:restore('PlayerManager.upgrade_value')
			ChatMessage('Disabled', 'STEAL PAGERS')
			return
		end

		PlayerManager.___upgrade_value = backuper:backup('PlayerManager.upgrade_value')
		function PlayerManager:upgrade_value(cat, upg, ...) 
			if cat == "player" and upg == "melee_kill_snatch_pager_chance" then 
				return 1
			end 
			return PlayerManager.___upgrade_value(self, cat, upg, ...) 
		end	
		ChatMessage('Enabled', 'STEAL PAGERS')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- NO PAGER ON DOMINATE
	local function pagedom()	
		Toggle.no_pager_dom = not Toggle.no_pager_dom
			
		if not Toggle.no_pager_dom then
			backuper:restore('CopLogicIntimidated._chk_begin_alarm_pager')
			ChatMessage('Disabled', 'NO PAGERS ON DOMINATE')
			return
		end
		
		backuper:backup('CopLogicIntimidated._chk_begin_alarm_pager')
		function CopLogicIntimidated._chk_begin_alarm_pager(data) end
		ChatMessage('Enabled', 'NO PAGERS ON DOMINATE')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- TAKE ALL INTEL
	local function takeintel()
		local instanttakeintel = {}
		local id
		for _,v in pairs(managers.interaction._interactive_objects) do
			if v.interaction then
				id = string.sub(v:interaction()._unit:name():t(), 1, 10)
				if id == "@IDcfbdf01" or id == "@IDdd0578d" or id == "@ID54e8d78"
				or id == "@IDbb82cfc" or id == "@ID39a5689" or id == "@ID22c41a3"
				or id == "@ID9140188" or id == "@IDdf59d98" or id == "@IDd2e9092"
				or id == "@IDad6fb7a" or id == "@ID9c5716b" or id == "@ID8834e3a" then
					table.insert(instanttakeintel, v:interaction())
				end 
			end 
		end
		for _,v in pairs(instanttakeintel) do v:interact(managers.player:player_unit()) end 
		ChatMessage('All Intel Has Been Secured', 'INTEL')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- CONVERT ALL ENEMIES
	local function convertall()
		if isHost() then
			tweak_data.upgrades.values.player.convert_enemies = {true}
			tweak_data.upgrades.values.player.convert_enemies_max_minions = {999999,999999}

			for _, data in pairs(managers.enemy:all_enemies()) do
				if Network:is_server() then
					managers.groupai:state():convert_hostage_to_criminal(data.unit)
				else
					managers.network:session():send_to_host("sync_interacted", data.unit, data.unit:id(), data.tweak_data, 1)
				end	
			end	
		end		
		ChatMessage('All Enemies Converted', 'MVP')
	end 
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- RANDOM PAGER
	local function randompage()
		Toggle.randompage = not Toggle.randompage

		if not Toggle.randompage then
			backuper:restore('CopBrain.clbk_alarm_pager')
			ChatMessage('Disabled', 'RANDOM PAGERS')
			return
		end

		ChatMessage('Enabled', 'RANDOM PAGERS')
		local _CopBrain_clbk_alarm_pager = backuper:backup('CopBrain.clbk_alarm_pager')
		function CopBrain:clbk_alarm_pager(ignore_this, data)
			-- Create a random number
			local rand = math.rand(1)
			-- 50% / 25% / 12.5% / 0% incrementing chances of no pager in a table
			local chance_table = {0.5, 0.25, 0.125, 0}
			-- Initalise table index as 1 if not defined
			self._cTableIndex = self._cTableIndex or 1
			-- Clamp the index so that it's never out of bounds
			self._cTableIndex = math.clamp(self._cTableIndex, 1, #chance_table)
			-- Establish the chance only if the guard is unalerted, by fetching the table value using the current index
			local chance = self._unit:movement():cool() and chance_table[self._cTableIndex] or 0
			-- If the random number is less than our current chance
			if self._alarm_pager_data.nr_calls_made == 0 and rand < chance then
				-- Increment the index
				self._cTableIndex = self._cTableIndex + 1
				-- Prevent the pager from going off
				self:end_alarm_pager()
				-- Enable bodybag interaction
				self:_chk_enable_bodybag_interaction()
				return
			end
			-- Otherwise run the original function
			_CopBrain_clbk_alarm_pager(self, ignore_this, data)
		end 
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- ENEMY MIND CONTROL --
	-- MAKE PIGS FLY
	local function pigsfly()
		if isHost() then
			local poses = {"e_sp_repel_into_window"}

			for k,v in pairs(managers.enemy:all_enemies()) do
				local act = {type = "act", variant = poses[math.random(1, #poses)], body_part = 1, align_sync = true}
				v.unit:movement():action_request(act)
			end
		end	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- QUITTER COPS	
	local function copsquit()
		if isHost() then
			local poses = {"hands_up" , "tied", "hands_back"}

			for k,v in pairs(managers.enemy:all_enemies()) do
				local act = {type = "act", variant = poses[math.random(3)], body_part = 1, align_sync = true}
				v.unit:movement():action_request(act)
			end	
		end	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- DRUNK PIGS	
	local function drunkpigs()	
		if isHost() then
			local poses = {"e_sp_dizzy_stand", "e_sp_dizzy_get_up"}

			for k,v in pairs(managers.enemy:all_enemies()) do
				local act = {type = "act", variant = poses[math.random(2)], body_part = 1, align_sync = true}
				v.unit:movement():action_request(act)
			end	
		end	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- CIVILIAN MIND CONTROL --
	-- MAKE CIVS DANCE SEXY
	local function civdance()	
		if isHost() then
			local poses = {"cf_sp_dance_slow", "cf_sp_dance_sexy", "cf_sp_pole_dancer_expert", "cf_sp_pole_dancer_basic"}

			for k,v in pairs(managers.enemy:all_civilians()) do
				local act = {type = "act", variant = poses[math.random(4)], body_part = 1, align_sync = true}
				v.unit:movement():action_request(act)		
			end	
		end 
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- MAKE CIVS SMOKE UP
	local function civsmoke()
		if isHost() then
			local poses = {"cm_sp_smoking_left1", "cf_sp_smoking_var1", "cm_sp_smoking_right1", "cmf_so_smoke"}

			for k,v in pairs(managers.enemy:all_civilians()) do
				local act = {type = "act", variant = poses[math.random(4)], body_part = 1, align_sync = true}
				v.unit:movement():action_request(act)
			end	
		end 
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	
	-- MAKE CIVS COVER AT YOUR FEET
	local function civcower()	
		if isHost() then
			local poses = {"cm_sp_recieving_cpr", "cm_sp_wounded_lying2", "cm_sp_wounded_lying", "cf_sp_lying_hurt"}

			for k,v in pairs(managers.enemy:all_civilians()) do
				local act = {type = "act", variant = poses[math.random(4)], body_part = 1, align_sync = true}
				v.unit:movement():action_request(act)
			end	
		end 
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- MAKE CIVS TALK ON PHONE
	local function phonycivs()
		if isHost() then
			local poses = {"cmf_so_answer_phone", "cmf_so_call_police", "cf_sp_sms_phone_var1", "cm_sp_phone1", "cm_sp_phone2"}

			for k,v in pairs(managers.enemy:all_civilians()) do
				local act = {type = "act", variant = poses[math.random(5)], body_part = 1, align_sync = true}
				v.unit:movement():action_request(act)
			end	
		end	
	end
-----------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
	StealthMenu = CustomMenuClass:new({ hasLoading = false })
	StealthMenu:addMainMenu('main_menu', {title = 'Stealth Menu - Select Menu or Toggle'})
	StealthMenu:addMenu('mind_enemies_menu', {title = 'Enemy Mind Control'})
	StealthMenu:addMenu('mind_civs_menu', {title = 'Civilian Mind Control'})
	
	StealthMenu:addInformationOption('main_menu', 'MIND CONTROL MENUS', {textColor = Color.red})
	-- Enemy Mind Control Menu
	if isHost() then
		StealthMenu:addMenuOption('main_menu', 'Enemy Mind Control Menu', 'mind_enemies_menu', {rectHighlightColor = Color.red})
	else
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	StealthMenu:addOption('mind_enemies_menu', 'Flying Piggies', {callback = pigsfly, closeMenu = true})
	StealthMenu:addOption('mind_enemies_menu', 'Quitter Cops', {callback = copsquit, closeMenu = true})
	StealthMenu:addOption('mind_enemies_menu', 'Drunk Pigs', {callback = drunkpigs, closeMenu = true})
	
	-- Civilian Mind Control Menu
	if isHost() then
		StealthMenu:addMenuOption('main_menu', 'Civilian Mind Control Menu', 'mind_civs_menu', {rectHighlightColor = Color.red})
	else
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	StealthMenu:addOption('mind_civs_menu', 'Dancing Puppets', {callback = civdance, closeMenu = true})
	StealthMenu:addOption('mind_civs_menu', 'Smoking Kills', {callback = civsmoke, closeMenu = true})
	StealthMenu:addOption('mind_civs_menu', 'Covering Sheep', {callback = civcower, closeMenu = true})
	StealthMenu:addOption('mind_civs_menu', 'Phony Yuppies', {callback = phonycivs, closeMenu = true})
	
	-- Toggles Column 1
	StealthMenu:addGap('main_menu')
	StealthMenu:addInformationOption('main_menu', 'TOGGLES & OPTIONS', {textColor = Color.DodgerBlue})
	if isHost() then
		if MVPConfig.Stealth_Menu_Config and MVPConfig.Cops_Dont_Shoot then	
			StealthMenu:addToggleOption('main_menu', 'Cops Dont Shoot', {callback = cops_dont_shoot, help = 'Cops Will Not Shoot You', toggle = true})
		else	
			StealthMenu:addToggleOption('main_menu', 'Cops Dont Shoot', {callback = cops_dont_shoot, help = 'Cops Will Not Shoot You'})
		end
		if MVPConfig.Stealth_Menu_Config and MVPConfig.Disable_Cameras then	
			StealthMenu:addToggleOption('main_menu', 'Disable Cameras', {callback = disable_cams, toggle = true})
		else	
			StealthMenu:addToggleOption('main_menu', 'Disable Cameras', {callback = disable_cams})
		end
		if MVPConfig.Stealth_Menu_Config and MVPConfig.Disable_Pagers then	
			StealthMenu:addToggleOption('main_menu', 'Disable Pagers', {callback = disable_pagers, toggle = true})
		else	
			StealthMenu:addToggleOption('main_menu', 'Disable Pagers', {callback = disable_pagers})
		end
	else
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	if MVPConfig.Stealth_Menu_Config and MVPConfig.Free_Civ_Kills then
		StealthMenu:addToggleOption('main_menu', 'Free Civilian Kills', {callback = free_kill, toggle = true})
	else
		StealthMenu:addToggleOption('main_menu', 'Free Civilian Kills', {callback = free_kill})
	end
	if isHost() then
		if MVPConfig.Stealth_Menu_Config and MVPConfig.No_Pager_Dominate then	
			StealthMenu:addToggleOption('main_menu', 'No Pager On Dominate', {callback = pagedom, toggle = true})
		else
			StealthMenu:addToggleOption('main_menu', 'No Pager On Dominate', {callback = pagedom})
		end
	else
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow })
	end
	
	-- Toggles Column 2
	StealthMenu:addGap('main_menu')
	StealthMenu:addGap('main_menu')
	StealthMenu:addGap('main_menu')
	StealthMenu:addGap('main_menu')
	StealthMenu:addGap('main_menu')
	if isHost() then
		if MVPConfig.Stealth_Menu_Config and MVPConfig.No_Panic then	
			StealthMenu:addToggleOption('main_menu', 'No Panic Button/Intel Burn', {callback = prevent_panic_buttons, toggle = true})
		else	
			StealthMenu:addToggleOption('main_menu', 'No Panic Button/Intel Burn', {callback = prevent_panic_buttons})
		end	
		if MVPConfig.Stealth_Menu_Config and MVPConfig.Dont_Call_Police then		
			StealthMenu:addToggleOption('main_menu', 'People Dont Call Police', {callback = people_dont_call_police, toggle = true})
		else	
			StealthMenu:addToggleOption('main_menu', 'People Dont Call Police', {callback = people_dont_call_police})
		end	
		if MVPConfig.Stealth_Menu_Config and MVPConfig.Lobotimize_AI then		
			StealthMenu:addToggleOption('main_menu', 'Lobotimize AI', {callback = lobai, toggle = true})
		else	
			StealthMenu:addToggleOption('main_menu', 'Lobotimize AI', {callback = lobai})
		end	
		if MVPConfig.Stealth_Menu_Config and MVPConfig.Random_Pagers then
			StealthMenu:addToggleOption('main_menu', 'Random Pagers', {callback = randompage, help = 'Enables Randomized Pagers', toggle = true})
		else	
			StealthMenu:addToggleOption('main_menu', 'Random Pagers', {callback = randompage, help = 'Enables Randomized Pagers'})
		end
		if MVPConfig.Stealth_Menu_Config and MVPConfig.Steal_Pagers then		
			StealthMenu:addToggleOption('main_menu', 'Steal Pagers', {callback = steal_pagers_on_melee, help = 'Disables Pager When You Melee A Guard', toggle = true})
		else	
			StealthMenu:addToggleOption('main_menu', 'Steal Pagers', {callback = steal_pagers_on_melee, help = 'Disables Pager When You Melee A Guard'})
		end
	else
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end

	-- Column 3
	StealthMenu:addGap('main_menu')
	StealthMenu:addGap('main_menu')
	StealthMenu:addGap('main_menu')
	StealthMenu:addGap('main_menu')
	StealthMenu:addGap('main_menu')
	StealthMenu:addToggleOption('main_menu', 'Unlock Messiah Charge', {callback = unlmessiah})
	StealthMenu:addGap('main_menu')
	if isHost() then
		StealthMenu:addOption('main_menu', 'Convert All Enemies', {callback = convertall, closeMenu = true })
	else
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	StealthMenu:addOption('main_menu', 'Remote Camera Access', {callback = remote_camera, closeMenu = true})
	if isHost() then
		StealthMenu:addOption('main_menu', 'Take All Intel', {callback = takeintel, help = 'Hit Twice for Intel In Safes'})
	else
		StealthMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
end
---------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------
if inGame() and isPlaying() then
	if StealthMenu:isOpen() then
		StealthMenu:close()
	else
		if ChangerMenu then
			if ChangerMenu:isOpen() then
				ChangerMenu:close()
			end	
		end
		if PlayerMenu then
			if PlayerMenu:isOpen() then
				PlayerMenu:close()
			end	
		end		
		if MissionMenu then
			if MissionMenu:isOpen() then
				MissionMenu:close()
			end	
		end		
		if InventoryMenu then
			if InventoryMenu:isOpen() then
				InventoryMenu:close()
			end	
		end
		if MoneyMenu then
			if MoneyMenu:isOpen() then
				MoneyMenu:close()
			end	
		end
		if NumpadMenu then
			if NumpadMenu:isOpen() then
				NumpadMenu:close()
			end	
		end	
		if InteractTimerMenu then	
			if InteractTimerMenu:isOpen() then
				InteractTimerMenu:close()
			end	
		end		
		StealthMenu:open()
	end	
end