if not InteractTimerMenu then
	
	-- PICKLOCK TIMER
	local function InteractPickLock()
		Toggle.picklock = not Toggle.picklock
		
		if not Toggle.picklock then
			tweak_data.interaction.pick_lock_easy.timer = 10
			tweak_data.interaction.pick_lock_easy_no_skill.timer = 7
			tweak_data.interaction.pick_lock_hard.timer = 45
			tweak_data.interaction.pick_lock_hard_no_skill.timer = 20
			tweak_data.interaction.pick_lock_deposit_transport.timer = 15
			ChatMessage('Disabled', 'PICK LOCK TIMER')
			return
		end
		
		tweak_data.interaction.pick_lock_easy.timer = 3
		tweak_data.interaction.pick_lock_easy_no_skill.timer = 3
		tweak_data.interaction.pick_lock_hard.timer = 3
		tweak_data.interaction.pick_lock_hard_no_skill.timer = 3
		tweak_data.interaction.pick_lock_deposit_transport.timer = 3
		ChatMessage('Enabled', 'PICK LOCK TIMER')
	end	
	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- ECM JAMMER OPEN TIMER
	local function InteractECMJam()
		Toggle.ecmjam = not Toggle.ecmjam
		
		if not Toggle.ecmjam then
			tweak_data.interaction.requires_ecm_jammer.timer = 4 
			tweak_data.interaction.requires_ecm_jammer_atm.timer = 8
			ChatMessage('Disabled', 'ECM OPEN TIMER')
			return
		end
		
		tweak_data.interaction.requires_ecm_jammer.timer = 3 
		tweak_data.interaction.requires_ecm_jammer_atm.timer = 3
		ChatMessage('Enabled', 'ECM OPEN TIMER')
	end	
	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- DRILL JAM/UPGRADE TIMER
	local function InteractDrillJam()
		Toggle.drilljam = not Toggle.drilljam
		
		if not Toggle.drilljam then
			tweak_data.interaction.drill_upgrade.timer = 10 
			tweak_data.interaction.drill_jammed.timer = 10
			tweak_data.interaction.lance_jammed.timer = 10
			tweak_data.interaction.lance_upgrade.timer = 10
			tweak_data.interaction.huge_lance_jammed.timer = 10
			ChatMessage('Disabled', 'DRILL JAM/UPGRADE TIMER')
			return
		end
		
		tweak_data.interaction.drill_upgrade.timer = 3 
		tweak_data.interaction.drill_jammed.timer = 3
		tweak_data.interaction.lance_jammed.timer = 3
		tweak_data.interaction.lance_upgrade.timer = 3
		tweak_data.interaction.huge_lance_jammed.timer = 3
		ChatMessage('Enabled', 'DRILL JAM/UPGRADE TIMER')
	end	
	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- REVIVE PLAYER TIMER
	local function InteractRevive()
		Toggle.revivetime = not Toggle.revivetime
		
		if not Toggle.revivetime then
			tweak_data.interaction.revive.timer = 6 
			ChatMessage('Disabled', 'REVIVE PLAYER TIMER')
			return
		end
		
		tweak_data.interaction.revive.timer = 3
		ChatMessage('Enabled', 'REVIVE PLAYER TIMER')
	end	
	--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- PAGER TIMER
	local function InteractPager()
		Toggle.pager = not Toggle.pager
		
		if not Toggle.pager then
			tweak_data.interaction.corpse_alarm_pager.timer = 10 
			ChatMessage('Disabled', 'PAGER TIMER')
			return
		end
		
		tweak_data.interaction.corpse_alarm_pager.timer = 3
		ChatMessage('Enabled', 'PAGER TIMER')
	end
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	InteractTimerMenu = CustomMenuClass:new()
	InteractTimerMenu:addMainMenu('main_menu', { title = 'Interaction Timer Menu - Select Option'})
	
	InteractTimerMenu:addInformationOption('main_menu', 'INTERACT TIMER OPTIONS (DECREASES TIMER TO 3 SEC.)', {textColor = Color.DodgerBlue})
	InteractTimerMenu:addToggleOption('main_menu', 'Drill Jam/Upgrade Timer', {callback = InteractDrillJam})
	InteractTimerMenu:addToggleOption('main_menu', 'ECM Open Timer', {callback = InteractECMJam})
	InteractTimerMenu:addToggleOption('main_menu', 'Pager Answer Timer', {callback = InteractPager})
	InteractTimerMenu:addToggleOption('main_menu', 'PickLock Timer', {callback = InteractPickLock})
	InteractTimerMenu:addToggleOption('main_menu', 'Revive Player Timer', {callback = InteractRevive})
end

if inGame() and isPlaying() then
	if InteractTimerMenu:isOpen() then
		InteractTimerMenu:close()
	else
		if MoneyMenu then	
			if MoneyMenu:isOpen() then
				MoneyMenu:close()
		end end
		if ChangerMenu then
			if ChangerMenu:isOpen() then
				ChangerMenu:close()
		end	end
		if PlayerMenu then
			if PlayerMenu:isOpen() then
				PlayerMenu:close()
		end	end		
		if StealthMenu then
			if StealthMenu:isOpen() then
				StealthMenu:close()
		end	end		
		if MissionMenu then
			if MissionMenu:isOpen() then
				MissionMenu:close()
		end	end
		if InventoryMenu then
			if InventoryMenu:isOpen() then
				InventoryMenu:close()
		end	end	
		if NumpadMenu then
			if NumpadMenu:isOpen() then
				NumpadMenu:close()
		end	end
		InteractTimerMenu:open()
end end