if not JobSelectMenu then
	-- CUSTOM LOBBY CREATOR by harfatus
	function CreateLobby(job, difficulty, permission, min_rep, drop_in, kicking_allowed, team_ai, level_id, auto_kick)
		Global.game_settings.permission = permission == nil and "private" or permission
		Global.game_settings.reputation_permission = type(min_rep) == "number" and min_rep or 0
		Global.game_settings.drop_in_allowed = drop_in == nil and true or drop_in
		Global.game_settings.kicking_allowed = kicking_allowed == nil and true or kicking_allowed
		Global.game_settings.team_ai = team_ai == nil and false or team_ai
		Global.game_settings.auto_kick = auto_kick == nil and false or auto_kick
		MenuCallbackHandler:start_job({job_id = job, difficulty = difficulty})
		if level_id then
			Global.game_settings.level_id = level_id
			Global.game_settings.mission = managers.job:current_mission()
		end
	end

	function add_job(data)
		CreateLobby(data.job_id, data.difficulty, managers.network.matchmake.lobby_handler and Global.game_settings.permission or "friends_only")
	end
	
	DifficultyMenu = CustomMenuClass:new()	
	PreGameMenu = PreGameMenu
	function mission(job)
		local job_id = job[1]
		local job_name = job[2]
		io.write("jobid:" .. job_id .. "\n")
		io.write("name: " .. job_name .. "\n")	
		DifficultyMenu:addMainMenu('main_menu', {title = 'Difficulty Selection Menu - Select Difficulty', maxRows = 11})
		DifficultyMenu:addInformationOption('main_menu', 'DIFFICULTY OPTIONS', {textColor = Color.DodgerBlue})
		DifficultyMenu:addOption('main_menu', 'Normal', {callback = add_job, callbackData = {difficulty = "normal", job_id = job_id}, closeMenu = true})
		DifficultyMenu:addOption('main_menu', 'Hard', {callback = add_job, callbackData = {difficulty = "hard", job_id = job_id}, closeMenu = true})
		DifficultyMenu:addOption('main_menu', 'Very Hard', {callback = add_job, callbackData = {difficulty = "overkill", job_id = job_id}, closeMenu = true})
		DifficultyMenu:addOption('main_menu', 'Overkill', {callback = add_job, callbackData = {difficulty = "overkill_145", job_id = job_id}, closeMenu = true})
		DifficultyMenu:addOption('main_menu', 'DeathWish', {callback = add_job, callbackData = {difficulty = "overkill_290", job_id = job_id}, closeMenu = true})
		if DifficultyMenu:isOpen() then
			DifficultyMenu:close()
		else
			if JobSelectMenu then
				if JobSelectMenu:isOpen() then
					JobSelectMenu:close()
				end
			end
			if PreGameMenu then
				if PreGameMenu:isOpen() then
					PreGameMenu:close()
				end
			end
			DifficultyMenu:open()
		end
	end	
	----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	-- MAIN MENU
	JobSelectMenu = CustomMenuClass:new()
	JobSelectMenu:addMainMenu('main_menu', {title = 'Main Job Menu - Select Contact/Option'})
	JobSelectMenu:addMenu('bain_menu', {title = 'Bain Selection Menu - Select Job'})
	JobSelectMenu:addMenu('hector_menu', {title = 'Hector Selection Menu - Select Job'})
	JobSelectMenu:addMenu('elephant_menu', {title = 'Elephant Selection Menu - Select Job'})
	JobSelectMenu:addMenu('dentist_menu', {title = 'Dentist Selection Menu - Select Job'})
	JobSelectMenu:addMenu('vlad_menu', {title = 'Vlad Selection Menu - Select Job'})
	JobSelectMenu:addMenu('butcher_menu', {title = 'The Butcher Selection Menu - Select Job'})
	
	-- CONTACT OPTIONS
	JobSelectMenu:addInformationOption('main_menu', 'CONTACT OPTIONS', {textColor = Color.red})
	JobSelectMenu:addMenuOption('main_menu', 'Bain Job Menu', 'bain_menu', {rectHighlightColor = Color.red})
	JobSelectMenu:addMenuOption('main_menu', 'Hector Job Menu', 'hector_menu', {rectHighlightColor = Color.red})
	JobSelectMenu:addMenuOption('main_menu', 'The Elephant Job Menu', 'elephant_menu', {rectHighlightColor = Color.red})
	JobSelectMenu:addMenuOption('main_menu', 'The Dentist Job Menu', 'dentist_menu', {rectHighlightColor = Color.red})
	JobSelectMenu:addMenuOption('main_menu', 'The Butcher Job Menu', 'butcher_menu', {rectHighlightColor = Color.red})
	JobSelectMenu:addMenuOption('main_menu', 'Vlad Job Menu', 'vlad_menu', {rectHighlightColor = Color.red})
	
	-- BAIN JOB MENU
	JobSelectMenu:addInformationOption('bain_menu', 'BAIN JOB OPTIONS', {textColor = Color.DodgerBlue})
	JobSelectMenu:addOption('bain_menu', 'Art Gallery', {callback = mission, callbackData = {"gallery", "Art Gallery"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Bank Heist PRO', {callback = mission, callbackData = {"branchbank_prof", "Bank Heist PRO"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Bank Heist: Deposit', {callback = mission, callbackData = {"branchbank_deposit", "Bank Heist:Deposit"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Bank Heist: Cash', {callback = mission, callbackData = {"branchbank_cash", "Bank Heist:Cash"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Bank Heist: Gold PRO', {callback = mission, callbackData = {"branchbank_gold_prof", "Bank Heist:Gold PRO"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Jewelry Store', {callback = mission, callbackData = {"jewelry_store", "Jewelry Store"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Diamond Store', {callback = mission, callbackData = {"family", "Diamond Store"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'GO Bank', {callback = mission, callbackData = {"roberts", "GO Bank"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Shadow Raid', {callback = mission, callbackData = {"kosugi", "Shadow Raid"}, closeMenu = true})
	
	-- BAIN JOB MENU COLUMN 2
	JobSelectMenu:addInformationOption('bain_menu', 'BAIN DLC JOB OPTIONS', {textColor = Color.DodgerBlue})
	JobSelectMenu:addOption('bain_menu', 'Transport: Crossroads DLC', {callback = mission, callbackData = {"arm_cro", "Transport:Crossroads"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Transport: Downtown DLC', {callback = mission, callbackData = {"arm_hcm", "Transport:Downtown"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Transport: Harbour DLC', {callback = mission, callbackData = {"arm_fac", "Transport:Harbour"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Transport: Underpass DLC', {callback = mission, callbackData = {"arm_und", "Transport:Underpass"}, closeMenu = true})
	JobSelectMenu:addOption('bain_menu', 'Transport: Park DLC', {callback = mission, callbackData = {"arm_par", "Transport:Park"}, closeMenu = true})
	
	-- HECTOR JOB MENU
	JobSelectMenu:addInformationOption('hector_menu', 'HECTOR JOB OPTIONS', {textColor = Color.DodgerBlue})
	JobSelectMenu:addOption('hector_menu', 'Firestarter', {callback = mission, callbackData = {"firestarter", "Firestarter"}, closeMenu = true})
	JobSelectMenu:addOption('hector_menu', 'Firestarter PRO', {callback = mission, callbackData = {"firestarter_prof", "Firestarter PRO"}, closeMenu = true})
	JobSelectMenu:addOption('hector_menu', 'Rats', {callback = mission, callbackData = {"alex", "Rats"}, closeMenu = true})
	JobSelectMenu:addOption('hector_menu', 'Rats PRO', {callback = mission, callbackData = {"alex_prof", "Rats PRO"}, closeMenu = true})
	JobSelectMenu:addOption('hector_menu', 'Watchdogs', {callback = mission, callbackData = {"watchdogs", "Watchdogs"}, closeMenu = true})
	JobSelectMenu:addOption('hector_menu', 'Watchdogs (Night)', {callback = mission, callbackData = {"watchdogs_night", "Watchdogs Night"}, closeMenu = true})
	JobSelectMenu:addOption('hector_menu', 'Watchdogs PRO', {callback = mission, callbackData = {"watchdogs_prof", "Watchdogs PRO"}, closeMenu = true})
	JobSelectMenu:addOption('hector_menu', 'Watchdogs PRO (Night)', {callback = mission, callbackData = {"watchdogs_night_prof", "Watchdogs PRO Night"}, closeMenu = true})
	
	-- ELEPHANT JOB MENU
	JobSelectMenu:addInformationOption('elephant_menu', 'THE ELEPHANT JOB OPTIONS', {textColor = Color.DodgerBlue})
	JobSelectMenu:addOption('elephant_menu', 'Big Oil PRO', {callback = mission, callbackData = {"welcome_to_the_jungle_prof", "Big Oil PRO"}, closeMenu = true})
	JobSelectMenu:addOption('elephant_menu', 'Big Oil PRO (Night)', {callback = mission, callbackData = {"welcome_to_the_jungle_night_prof", "Big Oil PRO Night"}, closeMenu = true})
	JobSelectMenu:addOption('elephant_menu', 'Election Day', {callback = mission, callbackData = {"election_day", "Election Day"}, closeMenu = true})
	JobSelectMenu:addOption('elephant_menu', 'Election Day PRO', {callback = mission, callbackData = {"election_day_prof", "Election Day PRO"}, closeMenu = true})
	JobSelectMenu:addOption('elephant_menu', 'Framing Frame', {callback = mission, callbackData = {"framing_frame", "Framing Frame"}, closeMenu = true})
	JobSelectMenu:addOption('elephant_menu', 'Framing Frame PRO', {callback = mission, callbackData = {"framing_frame_prof", "Framing Frame PRO"}, closeMenu = true})
	
	-- DENTIST JOB MENU
	JobSelectMenu:addInformationOption('dentist_menu', 'THE DENTIST JOB OPTIONS', {textColor = Color.DodgerBlue})
	JobSelectMenu:addOption('dentist_menu', 'Hoxton Breakout', {callback = mission, callbackData = {"hox", "Hoxton Breakout"}, closeMenu = true})
	JobSelectMenu:addOption('dentist_menu', 'Hoxton Breakout PRO', {callback = mission, callbackData = {"hox_prof", "Hoxton Breakout PRO"}, closeMenu = true})
	for i=4,10 do
	 	JobSelectMenu:addGap('dentist_menu')
	end
	JobSelectMenu:addInformationOption('dentist_menu', 'THE DENTIST DLC JOB OPTIONS', {textColor = Color.DodgerBlue})
	JobSelectMenu:addOption('dentist_menu', 'Hotline Miami DLC', {callback = mission, callbackData = {"mia", "Hotline Miami DLC"}, closeMenu = true})
	JobSelectMenu:addOption('dentist_menu', 'Hotline Miami PRO DLC', {callback = mission, callbackData = {"mia_prof", "Hotline Miami PRO DLC"}, closeMenu = true})
	JobSelectMenu:addOption('dentist_menu', 'The Big Bank DLC', {callback = mission, callbackData = {"big", "The Big Bank"}, closeMenu = true})
	JobSelectMenu:addOption('dentist_menu', 'The Diamond DLC', {callback = mission, callbackData = {"mus", "The Diamond"}, closeMenu = true})	
	
	-- BUTCHER JOB MENU
	JobSelectMenu:addInformationOption('butcher_menu', 'THE BUTCHER DLC JOB OPTIONS', {textColor = Color.DodgerBlue})
	JobSelectMenu:addOption('butcher_menu', 'The Bomb: DOCKYARD DLC', {callback = mission, callbackData = {"crojob1", "The Bomb: DOCKYARD DLC"}, closeMenu = true})
	JobSelectMenu:addOption('butcher_menu', 'The Bomb: FOREST DLC', {callback = mission, callbackData = {"crojob2", "The Bomb: FOREST DLC"}, closeMenu = true})
	JobSelectMenu:addOption('butcher_menu', 'The Bomb: FOREST DLC (Night)', {callback = mission, callbackData = {"crojob2_night", "The Bomb: FOREST DLC (Night)"}, closeMenu = true})

	-- VLAD JOB MENU
	JobSelectMenu:addInformationOption('vlad_menu', 'VLAD JOB OPTIONS', {textColor = Color.DodgerBlue})
	JobSelectMenu:addOption('vlad_menu', 'Four Stores', {callback = mission, callbackData = {"four_stores", "Four Stores"}, closeMenu = true})
	JobSelectMenu:addOption('vlad_menu', 'Mallcrasher', {callback = mission, callbackData = {"mallcrasher", "Mallcrasher"}, closeMenu = true})
	JobSelectMenu:addOption('vlad_menu', 'Nightclub', {callback = mission, callbackData = {"nightclub", "Nightclub"}, closeMenu = true})
	JobSelectMenu:addOption('vlad_menu', 'Ukrainian Job PRO', {callback = mission, callbackData = {"ukrainian_job_prof", "Ukrainian Job PRO"}, closeMenu = true})
	JobSelectMenu:addOption('vlad_menu', 'White XMAS', {callback = mission, callbackData = {"pines", "White XMAS"}, closeMenu = true})
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
if not inGame() and not isPlaying() then
	if JobSelectMenu:isOpen() then
		JobSelectMenu:close()
	else
		if PreGameMenu then
			if PreGameMenu:isOpen() then
				PreGameMenu:close()
			end
		end
		if DifficultyMenu then
			if DifficultyMenu:isOpen() then
				DifficultyMenu:close()
			end
		end
		JobSelectMenu:open()
	end
end


