function WeaponMenuConfig()
	-- WEAPON RELOAD SPEED BUFF
	if MVPConfig.Weapon_Reload_Speed_Multiplier then
		Toggle.reload_speed_multiplier = not Toggle.reload_speed_multiplier
		
		backuper:backup('NewRaycastWeaponBase.reload_speed_multiplier')
		function NewRaycastWeaponBase:reload_speed_multiplier()
			return MVPConfig.Weapon_Reload_Speed_Multiplier_Amount
		end
	end
	
	-- WEAPON SWAP SPEED BUFF
	if MVPConfig.Weapon_Swap_Speed_Multiplier then
		Toggle._get_swap_speed_multiplier = not Toggle._get_swap_speed_multiplier
		
		backuper:backup('PlayerStandard._get_swap_speed_multiplier')
		function PlayerStandard:_get_swap_speed_multiplier()
			return MVPConfig.Weapon_Swap_Speed_Multiplier_Amount or 1
		end
	end	
	
	-- WEAPON FIRE RATE BUFF
	if MVPConfig.Weapon_Fire_Rate_Multiplier then
		Toggle.fire_rate_multiplier = not Toggle.fire_rate_multiplier
		
		backuper:backup('NewRaycastWeaponBase.fire_rate_multiplier')
		function NewRaycastWeaponBase:fire_rate_multiplier()
			return MVPConfig.Weapon_Fire_Rate_Multiplier_Amount
		end
	end 
	
	-- WEAPON DAMAGE BUFF
	if MVPConfig.Weapon_Damage_Multiplier then
		Toggle.damage_buff = not Toggle.damage_buff
				
		local damage_bullet_original = backuper:backup('CopDamage.damage_bullet')
		function CopDamage:damage_bullet(attack_data)
			attack_data.damage = attack_data.damage * MVPConfig.Weapon_Damage_Multiplier_Amount
			return damage_bullet_original(self, attack_data)
		end
	end
	
	-- SENTRY GUN GOD MODE
	if MVPConfig.Sentry_God_Mode then
		Toggle.damage_bullet = not Toggle.damage_bullet
		
		backuper:backup("SentryGunDamage.damage_bullet")
		function SentryGunDamage:damage_bullet(attack_data) end
	end
	
	-- INFINITE SENTRY AMMO, NO RECOIL
	if MVPConfig.Sentry_Infinite_Ammo then
		Toggle.fire = not Toggle.fire
		
		backuper:backup("SentryGunWeapon.fire")
		function SentryGunWeapon:fire(blanks, expend_ammo)
			local fire_obj = self._effect_align[self._interleaving_fire]
			local from_pos = fire_obj:position()
			local direction = fire_obj:rotation():y()
			mvector3.spread(direction, tweak_data.weapon[self._name_id].SPREAD * self._spread_mul)
			World:effect_manager():spawn(self._muzzle_effect_table[self._interleaving_fire ]) -- , normal = col_ray.normal})
			if self._use_shell_ejection_effect then
				World:effect_manager():spawn(self._shell_ejection_effect_table) 
			end
				local ray_res = self:_fire_raycast(from_pos, direction, blanks)
				if self._alert_events and ray_res.rays then
					RaycastWeaponBase._check_alert(self, ray_res.rays, from_pos, direction, self._unit)
				end
			return ray_res
		end
	end
end