if RequiredScript == "lib/managers/localizationmanager" then
    LocalizationManager._text = LocalizationManager.text
    function LocalizationManager:text(string_id, macros)
        return localization_strings[string_id] or self:_text(string_id, macros)
    end
elseif RequiredScript == "lib/managers/chatmanager" then
    ChatGui.__update_caret = ChatGui.__update_caret or ChatGui.update_caret
    function ChatGui:update_caret(...)
        if alive(self._input_panel) then
            return self:__update_caret(...)
        end
    end
elseif RequiredScript == "lib/managers/menumanager" then
    SkillProfilerInspectPlayerCreator = class()
    getmetatable(PackageManager).__script_data =  getmetatable(PackageManager).__script_data or  getmetatable(PackageManager).script_data

    function SkillProfilerInspectPlayerCreator:InsertSkillProfiler(scriptdata)
        for k, v in ipairs(scriptdata[1]) do
            for k2, v2 in ipairs(v) do
                if v2.name == "skilltree" then
                    table.insert(scriptdata[1][k], k2 + 1, {
                        name = "skill_profiler",
                        text_id = "skill_profiler",
                        help_id = "skill_profiler_desc",
                        sign_in = false,
                        callback = "skillprofiler",
                        _meta = "item"
                    })
                    break
                end
            end
        end
    end
    
    function SkillProfilerInspectPlayerCreator:InsertInspectPlayer(scriptdata)
        for i, v in ipairs(scriptdata[1]) do
            for i2, v2 in ipairs(v) do
                if v2.name == "kick_player" then
                    table.insert(scriptdata[1][i], i2, {
                        name = "menu_inspect_player",
                        next_node = "menu_inspect_player",
                        _meta = "item",
                        visible_callback = "is_multiplayer",
                        text_id = "menu_inspect_player",
                        help_id = "menu_inspect_player_desc"
                    })
                    break
                end
            end
            if v.name and v.name == "kick_player" then
                local Inspect_Player_Clone = clone(v)
                Inspect_Player_Clone.modifier = "InspectPlayer"
                Inspect_Player_Clone.name = "menu_inspect_player"
                Inspect_Player_Clone.topic_id = "menu_inspect_player"
                table.insert(scriptdata[1], Inspect_Player_Clone)
                break
            end
        end
    end

    InspectPlayer = InspectPlayer or class()
    function InspectPlayer:modify_node(node, up)
        local new_node = deep_clone(node)
        if managers.network:session() then
            for _, peer in pairs(managers.network:session():peers()) do
                local params = {
                    name = peer:name(),
                    text_id = peer:name() .. " (" .. (peer:rank() > 0 and managers.experience:rank_string(peer:rank()) .. "-" or "") .. (peer:level() or "") .. ")",
                    callback = "Inspect_Player",
                    to_upper = false,
                    localize = "false",
                    rpc = peer:rpc(),
                    peer = peer
                }
                local new_item = node:create_item(nil, params)
                new_node:add_item(new_item)
            end
        end
        managers.menu:add_back_button(new_node)
        return new_node
    end


    getmetatable(PackageManager).script_data = function(self, type_id, path_id, ...)
        local scriptdata = self:__script_data(type_id, path_id, ...)
        if type_id == Idstring("menu") and path_id == Idstring("gamedata/menus/start_menu") then
            SkillProfilerInspectPlayerCreator:InsertSkillProfiler(scriptdata)
            SkillProfilerInspectPlayerCreator:InsertInspectPlayer(scriptdata)
        elseif type_id == Idstring("menu") and path_id == Idstring("gamedata/menus/pause_menu") then
            SkillProfilerInspectPlayerCreator:InsertInspectPlayer(scriptdata)
        end
        return scriptdata
    end

    function MenuCallbackHandler:skillprofiler()
        managers.skilltree:profileMain()
    end
    
    function MenuCallbackHandler:Inspect_Player(item)
        Steam:overlay_activate("url", string.format("http://pd2stats.com/stats.php?profiles=%s#skilldata", item:parameters().peer:user_id()))
        managers.menu:back(true)
    end
elseif RequiredScript == "lib/managers/skilltreemanager" then
-----------------------------------------------------------------------------------------------------------------
-- EDIT HERE!!!!!!!!!!!!!!!!!!!!
-----------------------------------------------------------------------------------------------------------------
    localization_strings = localization_strings or { -- These are the custom strings....edit these....SIMPLE!!
        skill_profiler = "Skill \/ Build Profiler",
        skill_profiler_desc = "Manage and respec between various custom skill \/ build profiles.",
        skill_profiler_title = "Skill \/ Build Tree Profiler",
        skill_profiler_text = "Select what you would like to do with your Skill Tree \/ Build Profiles.",
        skill_profiler_option_text = "Select Profile to %s",
        skill_profiler_deletion_warning_text = "Are you sure you wish to delete profile %s",
        skill_profiler_respec_warning_text = "WARNING: Loading this profile will cost %s%s. Are you sure you wish to continue?",
        skill_profiler_respec_cheaper_text = "NOTICE: Loading this profile will refund you %s%s. Are you sure you wish to continue?",
        skill_profiler_default_profile_name = "Profile %d",
        skill_profiler_default_initialization_profile_name = "Default Initialization Skills \/ Build",
        skill_profiler_profile_options = {"Load Profile", "Save Profile", "Add Profile", "Delete Profile", "Rename Profile", "Swap Position of Profile", "Swap with previous"}, --YOU CAN MODIFY TEXT, BUT DO NOT REORDER.
        skill_profiler_rename_text = "Enter new name for %s",
        skill_profiler_rename_prompt = "Rename>",
        skill_profiler_cash_sign = "$",
        skill_profiler_dialog_no = "No",
        skill_profiler_dialog_yes = "Yes",
        -- Inspect Player Strings
        menu_inspect_player = "Inspect Player",
        menu_inspect_player_desc = "Opens the PD2Stats webpage for a player in this lobby on your Steam Overlay."
    }
    --[[
    These values are your configuration options essentially...change to suit your needs.
    Credits:
    @B1313 (Reverse Engineering, Fixing the million mistakes, Rewriting various aspects, Redoing the entire file/code, fixes to random spontaneous bugs, Lua serializer retool, SteamAPI replacing, fixing Oli's shitty grammar and spelling).
    @SquareOne (Dumping HoxHud Files, General Help/Advice, and telling me to fuck JSON and use Lua)
    @Harfatus (AKA Olipro) (Crappy code, 69 errors, and shitty grammatical skills)
    @ Google (Lua Parser)
    ]]--
    local switch_profiles_for_free = true -- Switch profiles for free
    local override_respec_cost_warning = false --[[ No warning message on profile loading 
    (Note: if you're profile matches your current build then it will still load the profile and not charge you, but you won't see a message.]]
    local total_number_of_skill_profiles = 5 -- Total number of profiles initiated on startup
    local skill_build_profile_file_path = "MVP/Main/PostRequire/Skill & Build Profiles.lua" --[[ Where you want to save your profiles...starting from the root PAYDAY 2 directory. 
    (I recommend you don't change it as if the path/file is nil (AKA Doesn't exist) it will crash and I am too lazy to make a pdofile function).]]
    ----------------------------------------------------------------------------------------------------
    -- DO NOT EDIT BELOW THIS LINE --
    -----------------------------------------------------------------------------------------------------
    localization_strings.dialog_no = localization_strings.skill_profiler_dialog_no
    localization_strings.dialog_yes = localization_strings.skill_profiler_dialog_yes
    localization_strings.skillprofiler_title = localization_strings.skill_profiler_title
    localization_strings.skillprofiler_text = localization_strings.skill_profiler_text
    localization_strings.skillprofiler_op_text = localization_strings.skill_profiler_option_text
    localization_strings.skillprofiler_del_text = localization_strings.skill_profiler_deletion_warning_text
    localization_strings.respec_warn_text = localization_strings.skill_profiler_respec_warning_text
    localization_strings.respec_cheaper_text = localization_strings.skill_profiler_respec_cheaper_text
    localization_strings.default_profile_name = localization_strings.skill_profiler_default_profile_name
    localization_strings.bootup_profile_name = localization_strings.skill_profiler_default_initialization_profile_name
    localization_strings.profile_ops = localization_strings.skill_profiler_profile_options
    localization_strings.rename_text = localization_strings.skill_profiler_rename_text
    localization_strings.rename_prompt = localization_strings.skill_profiler_rename_prompt
    localization_strings.cash_sign = localization_strings.skill_profiler_cash_sign
    
    SkillTreeManager.PROFILE_OPERATIONS = {
        LOAD = 1,
        SAVE = 2,
        ADD = 3,
        DEL = 4,
        RENAME = 5,
        SWAP = 6,
        SWAP2 = 7
    }
    SkillTreeManager._init = SkillTreeManager.init
    function SkillTreeManager:init()
        --[[
        No more stupid HoxHud Tweak Data crap! :) 
        Configuration options above!!!
        DO NOT EDIT THIS AT ALL!!!
        ]]
        self._switchProfilesForFree = switch_profiles_for_free or false
        self._totalSkillProfiles = total_number_of_skill_profiles or 5
        self._skip_respec_cost_warning = override_respec_cost_warning or false
        self._profileFile = skill_build_profile_file_path or "MVP/Main/PostRequire/Skill & Build Profiles.lua" -- We're in Lua now...YAY!!!
        self._strings = localization_strings
        return self:_init()
    end
    
    function SkillTreeManager:repairProfiles() -- Function Reworked
        --[[ Redid the entire function from luadec...AKA rewrote it]]
        local table_one = {}
        local table_two = {}
        for i, v in ipairs(self._skillProfiles) do
            table.insert(table_one, v)
            table_two[i] = true
        end
        for k, v in pairs(self._skillProfiles) do
            if tonumber(k) and not table_two[k] then
                table.insert(table_one, v)
            elseif not table_two[k] then
                table_one[k] = v
            end
        end
        while #table_one.names < #table_one do
            table.remove(table_one, #table_one)
        end
        self._skillProfiles = table_one
        self._skillProfiles.version = 2
        self:doSave()
    end

    function SkillTreeManager:upgradeToVersion3()
        self._skillProfiles.specializations = {}
        for _FORV_4_, _FORV_5_ in ipairs(self._skillProfiles) do
            self._skillProfiles.specializations[_FORV_4_] = 0
        end
        self._skillProfiles.version = 3
    end

    function SkillTreeManager:upgradeToVersion4()
        self._skillProfiles.loadout_slots = {}
        self._skillProfiles.version = 4
    end

    function SkillTreeManager:profileInit() -- Essentially rewrote this function too
        local file = io.open(self._profileFile, "r") -- No more JSON Shit...Lua all the way.
        if file then
            local integrity_check = file:read("*a")
            local loaded_profile = dofile(self._profileFile) -- Clever work around to JSON and loadfile error.
            if integrity_check == "" then -- Fix to accidentally make a bad write the Lua file.
                io.stderr:write("Lua file was incorrectly saved. Reinitializing the file\n")
                file:close()
                os.remove(self._profileFile) -- Removes the bad Lua write
                return self:profileInit() -- Rewrites the file by recursion (well, sort of) :)
            end
            self._skillProfiles = serialize_intializer()
            file:close()
            if type(self._skillProfiles) ~= "table" then
                io.stderr:write("Warning: Lua was found to be invalid, reiniting profiles\n") -- You did something wrong...
                self._skillProfiles = nil
            elseif not self._skillProfiles.version then
                self:repairProfiles()
                self:upgradeToVersion3()
                self:upgradeToVersion4()
            elseif self._skillProfiles.version == 2 then
                self:upgradeToVersion3()
                self:upgradeToVersion4()
            elseif self._skillProfiles.version == 3 then
                self:upgradeToVersion4()
            end
        end
        if not self._skillProfiles or #self._skillProfiles.names == 0 then
            io.stderr:write("Initializing all profiles with your current skill tree\n")
            self._skillProfiles = {
                names = {},
                specializations = {},
                loadout_slots = {}
            }
            for _FORV_4_ = 1, self._totalSkillProfiles do
                self._skillProfiles[_FORV_4_] = deep_clone(self._global.skills)
                self._skillProfiles.names[_FORV_4_] = string.format(self._strings.default_profile_name, _FORV_4_)
                self._skillProfiles.specializations[_FORV_4_] = 0
            end
        end
        self._bootupProfile = deep_clone(self._global.skills)
        self._bootupSpecialization = self:digest_value(self._global.specializations.current_specialization, false) or 0
        self._bootupLoadout = {
            managers.blackmarket:equipped_weapon_slot("primaries"),
            managers.blackmarket:equipped_weapon_slot("secondaries"),
            managers.blackmarket:equipped_melee_weapon_slot(),
            managers.blackmarket:equipped_armor_slot(),
            Global.player_manager.kit.equipment_slots[1]
        }
        --[[ Following 3 lines are made by me to fix yet another bug in here...]]
        self._skillProfiles[-1] = self._bootupProfile -- Learn to define your shit so it's not nil in every other place
        self._skillProfiles.specializations[-1] = self._bootupSpecialization -- Learn to define your shit so it's not nil in every other place
        self._skillProfiles.loadout_slots[-1] = self._bootupLoadout -- Learn to define your shit so it's not nil in every other place
        self._treeSkillFinder = {}
        for _FORV_4_, _FORV_5_ in pairs(tweak_data.skilltree.trees) do
            for _FORV_9_, _FORV_10_ in pairs(_FORV_5_.tiers) do
                for _FORV_14_, _FORV_15_ in pairs(_FORV_10_) do
                    self._treeSkillFinder[_FORV_15_] = _FORV_4_
                end
            end
        end
        self._profilerInited = true
    end

    function SkillTreeManager:profileMain()
        if not self._profilerInited then
            self:profileInit()
        end
        SimpleMenuV2:new(self._strings.skillprofiler_title, self._strings.skillprofiler_text, {
            {
                text = self._strings.profile_ops[self.PROFILE_OPERATIONS.LOAD], -- Fixed (stupid JSON Parse shit) and default skills actually being something Oli doesn't know how to initialize shit like bootup skills (of which is fucking dumb)
                callback = self.profileChange,
                data = self.PROFILE_OPERATIONS.LOAD,
                Class = self
            },
            {
                text = self._strings.profile_ops[self.PROFILE_OPERATIONS.SAVE], -- Fixed (stupid JSON Parse shit is done through Lua)
                callback = self.profileChange,
                data = self.PROFILE_OPERATIONS.SAVE,
                Class = self
            },
            {
                text = self._strings.profile_ops[self.PROFILE_OPERATIONS.RENAME], -- Fixed, guess who made a new version of SimpleInput? I did it for him.
                callback = self.profileChange,
                data = self.PROFILE_OPERATIONS.RENAME,
                Class = self
            },
            {
                text = self._strings.profile_ops[self.PROFILE_OPERATIONS.ADD], -- Works as intended from out of the box...surprisingly.
                callback = self.newProfile,
                data = self.PROFILE_OPERATIONS.ADD,
                Class = self
            },
            {
                text = self._strings.profile_ops[self.PROFILE_OPERATIONS.DEL], -- Works as intended from out of the box...surprisingly.
                callback = self.profileChange,
                data = self.PROFILE_OPERATIONS.DEL,
                Class = self
            },
            {
                text = self._strings.profile_ops[self.PROFILE_OPERATIONS.SWAP], -- Fixed for grammar...like seriously?
                callback = self.profileChange,
                data = self.PROFILE_OPERATIONS.SWAP,
                Class = self
            },
            {
                text = managers.localization:text("dialog_cancel"),
                is_cancel_button = true
            }
        }):show()
    end

    function SkillTreeManager:profileChange(_ARG_1_)
        local skill_table = {} -- another decomp fix....or maybe it was Oli, it's getting hard to tell.
        if _ARG_1_ == self.PROFILE_OPERATIONS.LOAD then
            table.insert(skill_table, {
                text = self._strings.bootup_profile_name .. " - " .. managers.localization:text(tweak_data.skilltree.specializations[self._bootupSpecialization].name_id),
                callback = managers.skilltree.doProfileOp,
                data = {profileID = -1, action = _ARG_1_},
                Class = self
            })
        end
        for _FORV_6_, _FORV_7_ in ipairs(self._skillProfiles.names) do
            _FORV_7_ = _FORV_7_ .. (0 < (self._skillProfiles.specializations[_FORV_6_] or 0) and " - " .. managers.localization:text(tweak_data.skilltree.specializations[self._skillProfiles.specializations[_FORV_6_] or 0].name_id) or "")
            table.insert(skill_table, {
                text = _FORV_7_,
                callback = managers.skilltree.doProfileOp,
                data = {profileID = _FORV_6_, action = _ARG_1_},
                Class = managers.skilltree
            })
        end
        table.insert(skill_table, {
            text = managers.localization:text("dialog_cancel"),
            is_cancel_button = true,
            callback = self.profileMain,
            Class = self
        })
        --[[ Delete the BELOW lines if you want an "original" decompile]]
        if _ARG_1_ == self.PROFILE_OPERATIONS.SWAP2 then -- Grammar Fixes, professionalism is something Oli might want to strive for.
            self._strings.profile_ops[7] = self._strings.profile_ops[7]:lower() -- Now it doesn't look like shit and is lower case.
        elseif _ARG_1_ == self.PROFILE_OPERATIONS.SWAP then
            self._strings.profile_ops[6] = self._strings.profile_ops[6]:lower()   -- again...
        end
        --[[ STOP!!! Delete the ABOVE lines if you want an "original" decompile]]
        SimpleMenuV2:new(self._strings.skillprofiler_title, string.format(self._strings.skillprofiler_op_text, self._strings.profile_ops[_ARG_1_]), skill_table):show()
    end

    function SkillTreeManager:newProfile()
        self._skillProfiles[#self._skillProfiles.names + 1] = deep_clone(self._global.skills)
        self._skillProfiles.names[#self._skillProfiles.names + 1] = string.format(self._strings.default_profile_name, #self._skillProfiles.names + 1)
        self._skillProfiles.specializations[#self._skillProfiles.names + 1] = self:digest_value(self._global.specializations.current_specialization, false) or 0
        self:doSave()
        self:profileMain()
    end

    function SkillTreeManager:doProfileOp(_ARG_1_)
        if _ARG_1_.action == self.PROFILE_OPERATIONS.SAVE then
            self:saveProfile(_ARG_1_.profileID)
        elseif _ARG_1_.action == self.PROFILE_OPERATIONS.LOAD then
            --[[
            Had to fix a ton of shit here
            bootup skills is a fucking stupid idea and nightmare. It's profileID is -1, but it's never declared.
            I had to do that in the profileInit function myself...shocking
            So I had to fix it and make it equal to bootup[insert_fucking_thing_here] of which can still not work as I am not redoing all this shit.
            It doesn't crash now or whatever or fuck up the skill profiles, but whatever.
            Should work as intended but if it crashes...c'est la vie.
            ]]
            local first_arg = self._skillProfiles[-1] -- can also be self._bootupProfile
            local second_arg = self._skillProfiles.specializations[-1] -- can also be self._bootupSpecialization
            local third_arg = self._skillProfiles.loadout_slots[-1] -- self._bootupLoadout
            if _ARG_1_.profileID ~= -1 or not self._bootupProfile then
                first_arg = self._skillProfiles[_ARG_1_.profileID]
            end
            if _ARG_1_.profileID ~= -1 or not self._bootupSpecialization then
                second_arg = self._skillProfiles.specializations[_ARG_1_.profileID]
            end
            if _ARG_1_.profileID ~= -1 or not self._bootupLoadout then
                third_arg = self._skillProfiles.loadout_slots[_ARG_1_.profileID]
            end
            if not self._skip_respec_cost_warning and not self:_is_tree_identical_to_equipped(self._skillProfiles[_ARG_1_.profileID]) then
                SimpleMenuV2:new(self._strings.skillprofiler_title, string.format(self:get_tree_switch_cost(self._skillProfiles[_ARG_1_.profileID]) > 0 and self._strings.respec_warn_text or self._strings.respec_cheaper_text, managers.localization:text("cash_sign"), managers.money:add_decimal_marks_to_string(tostring(math.abs((self:get_tree_switch_cost(self._skillProfiles[_ARG_1_.profileID])))))), {
                    {
                        text = managers.localization:text("dialog_yes"),
                        callback = function()
                            self:loadProfile(first_arg, second_arg, third_arg)
                        end
                    },
                    {
                        text = managers.localization:text("dialog_no"),
                        is_cancel_button = true
                    }
                }):show()
            else
                self:loadProfile(first_arg, second_arg, third_arg)
            end
        elseif _ARG_1_.action == self.PROFILE_OPERATIONS.RENAME then
            self._rename_input = SimpleInputV2:new({ 
                --[[
                New Version of SimpleInput that I partially decompiled....
                not perfect as it's not the original (for all I know)...but fuck it, it's good and works perfectly :)
                ]]
                intro = string.format(self._strings.rename_text, self._skillProfiles.names[_ARG_1_.profileID]),
                intro_color = Color.green, -- Ugly ass color by Oli...I would change to white...but your presonal pref.
                prompt = self._strings.rename_prompt,
                cblk = self.renameProfile,
                data = _ARG_1_.profileID,
                cblkself = self
            })
            self._rename_input:hide() -- Fixes slight bug where you could only switch it once if you started fucking around...dirty fix.
            self._rename_input:show()
        elseif _ARG_1_.action == self.PROFILE_OPERATIONS.DEL then
            SimpleMenuV2:new(self._strings.skillprofiler_title, string.format(self._strings.skillprofiler_del_text, self._skillProfiles.names[_ARG_1_.profileID]), {
                {
                    text = managers.localization:text("dialog_yes"),
                    callback = function()
                        table.remove(self._skillProfiles, _ARG_1_.profileID)
                        table.remove(self._skillProfiles.names, _ARG_1_.profileID)
                        table.remove(self._skillProfiles.specializations, _ARG_1_.profileID)
                        self:doSave()
                        self:profileMain()
                    end
                },
                {
                    text = managers.localization:text("dialog_no"),
                    is_cancel_button = true
                }
            }):show()
        elseif _ARG_1_.action == self.PROFILE_OPERATIONS.SWAP then
            self._swapStageOne = _ARG_1_.profileID
            self:profileChange(self.PROFILE_OPERATIONS.SWAP2)
        elseif _ARG_1_.action == self.PROFILE_OPERATIONS.SWAP2 then
            self:swapProfiles(self._swapStageOne, _ARG_1_.profileID)
            self._swapStageOne = nil
        end
    end

    function SkillTreeManager:doSave()
        --[[ Changed from shitty JSON Parsing and shitty SteamAPI shit...if you want JSON, then you make it.
        Lua is faster, easier, and more logical as we're already in it.
        ]]
        local file = io.open(self._profileFile, "w")
        if not file then
            io.stderr:write("Failed opening Lua\n")
            return
        end
        file:write(Serializer("Skill_Build_Profiles", self._skillProfiles)) -- Very Nice Serializer I found online and did a little tweaking to make it work here :)
        file:close()
    end

    function SkillTreeManager:renameProfile(message, id)
        --[[ This function is/was a disaster 
        I couldn't call it from the menu as the newer SimpleInput didn't decompile nicely and is missing a key component (how convenient, huh?)
        Bottom line...it's shitty, imperfect and I had to pull out some dirty fixes
        
        Update:
        Fixed it...of course. :)
        Perfect now :)
        ]]
        if not message or message == "" then -- Check if you're troll
            return
        end
        self._skillProfiles.names[id] = message
        self:doSave()
        self._rename_input:hide()
        self:profileMain()
    end

    function SkillTreeManager:saveProfile(_ARG_1_)
        self._skillProfiles[_ARG_1_] = deep_clone(self._global.skills)
        self._skillProfiles.specializations[_ARG_1_] = self:digest_value(self._global.specializations.current_specialization, false) or 0 -- Nice PocoHud theft Oli ;)
        self._skillProfiles.loadout_slots[_ARG_1_] = { -- Nice PocoHud theft Oli ;)
            managers.blackmarket:equipped_weapon_slot("primaries"),
            managers.blackmarket:equipped_weapon_slot("secondaries"),
            managers.blackmarket:equipped_melee_weapon_slot(),
            managers.blackmarket:equipped_armor_slot(),
            Global.player_manager.kit.equipment_slots[1]
        }
        self:doSave()
        self:profileMain()
    end

    function SkillTreeManager:swapProfiles(_ARG_1_, _ARG_2_)
        self._skillProfiles[_ARG_1_] = self._skillProfiles[_ARG_2_]
        self._skillProfiles[_ARG_2_] = self._skillProfiles[_ARG_1_]
        self._skillProfiles.names[_ARG_1_] = self._skillProfiles.names[_ARG_2_]
        self._skillProfiles.names[_ARG_2_] = self._skillProfiles.names[_ARG_1_]
        self._skillProfiles.specializations[_ARG_1_] = self._skillProfiles.specializations[_ARG_2_]
        self._skillProfiles.specializations[_ARG_2_] = self._skillProfiles.specializations[_ARG_1_]
        self._skillProfiles.loadout_slots[_ARG_1_] = self._skillProfiles.loadout_slots[_ARG_2_]
        self._skillProfiles.loadout_slots[_ARG_2_] = self._skillProfiles.loadout_slots[_ARG_1_]
        self:doSave()
        self:profileMain()
    end

    function SkillTreeManager:calc_skillpoint_cost(_ARG_1_, _ARG_2_, _ARG_3_, _ARG_4_)
        for _FORV_9_, _FORV_10_ in ipairs(_ARG_3_.tiers) do
            if table.contains(_FORV_10_, _ARG_2_) then
                return managers.money:get_skillpoint_cost(_ARG_1_, _FORV_9_, self:get_skill_points(_ARG_2_, _ARG_4_))
            end
        end
    end

    function SkillTreeManager:get_tree_switch_cost(_ARG_1_)
        local cost = 0
        for i = 1, #tweak_data.skilltree.trees do
            if self:tree_unlocked(i) then
                cost = cost - managers.money:get_skilltree_tree_respec_cost(i, false)
            end
        end
        for _FORV_6_, _FORV_7_ in pairs(tweak_data.skilltree.trees) do
            if _ARG_1_[_FORV_7_.skill] and _ARG_1_[_FORV_7_.skill].unlocked > 0 then
                cost = cost + managers.money:get_skillpoint_cost(_FORV_7_, nil, self:get_skill_points(_FORV_7_.skill, self:next_skill_step(_FORV_7_.skill)))
                for _FORV_11_, _FORV_12_ in pairs(_FORV_7_.tiers) do
                    for _FORV_16_, _FORV_17_ in pairs(_FORV_12_) do
                        for _FORV_21_ = 1, _ARG_1_[_FORV_17_].unlocked do
                            cost = cost + self:calc_skillpoint_cost(_FORV_6_, _FORV_17_, _FORV_7_, _FORV_21_)
                        end
                    end
                end
            end
        end
        return cost
    end

    function SkillTreeManager:loadProfile(_ARG_1_, _ARG_2_, _ARG_3_)
        if self._switchProfilesForFree then
            function managers.money.on_respec_skilltree(...)
            end
            function managers.money.on_skillpoint_spent(...)
            end
        end
        --[[function managers.statistics.publish_skills_to_steam(...)
        end]]-- Lol :p Nope
        if not self:_is_tree_identical_to_equipped(_ARG_1_) then
            for _FORV_10_ = 1, #tweak_data.skilltree.trees do
                if self:tree_unlocked(_FORV_10_) then
                    self:on_respec_tree(_FORV_10_, false)
                end
            end
            for _FORV_10_, _FORV_11_ in ipairs(tweak_data.skilltree.trees) do
                if _ARG_1_[_FORV_11_.skill] and _ARG_1_[_FORV_11_.skill].unlocked > 0 then
                    self:unlock_tree(_FORV_10_)
                    for _FORV_15_, _FORV_16_ in ipairs(_FORV_11_.tiers) do
                        if self:tier_unlocked(_FORV_10_, _FORV_15_) then
                            for _FORV_20_, _FORV_21_ in ipairs(_FORV_16_) do
                                for _FORV_25_ = 1, _ARG_1_[_FORV_21_].unlocked do
                                    if managers.money:can_afford_spend_skillpoint(_FORV_10_, _FORV_15_, self:get_skill_points(_FORV_21_, self:next_skill_step(_FORV_21_))) then
                                        self:unlock(_FORV_10_, _FORV_21_)
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
        self:set_current_specialization(_ARG_2_) -- Nice PocoHud theft Oli ;)
        self:_equip_loadout_items(_ARG_3_) -- Nice PocoHud theft Oli ;)
        managers.money.on_respec_skilltree = managers.money.on_respec_skilltree
        managers.money.on_skillpoint_spend = managers.money.on_skillpoint_spent -- Spelling: spend ~= spent just for reference... :)
        managers.statistics.publish_skills_to_steam = managers.statistics.publish_skills_to_steam
        --[[if SystemInfo:platform() == Idstring("WIN32") then
            managers.statistics:publish_skills_to_steam()
        end]]-- Awe.........too bad :p
        managers.menu_component:refresh_player_profile_gui()
        if managers.menu_component._skilltree_gui then
            managers.menu_component:close_skilltree_gui()
            managers.menu_component:_create_skilltree_gui()
        end
    end

    function SkillTreeManager:_equip_loadout_items(_ARG_1_) -- Function Reworked (again) also.....Nice PocoHud theft Oli ;)
        if not _ARG_1_ then
            return
        end
        if managers.blackmarket:get_crafted_category_slot("primaries", _ARG_1_[1]) and (function(self)
            return managers.blackmarket:weapon_unlocked(self) and managers.experience:current_level() >= managers.blackmarket:weapon_level(self)
        end)(managers.blackmarket:get_crafted_category_slot("primaries", _ARG_1_[1]).weapon_id) then
            managers.blackmarket:equip_weapon("primaries", _ARG_1_[1])
        end
        if managers.blackmarket:get_crafted_category_slot("secondaries", _ARG_1_[2]) and (function(self)
            return managers.blackmarket:weapon_unlocked(self) and managers.experience:current_level() >= managers.blackmarket:weapon_level(self)
        end)(managers.blackmarket:get_crafted_category_slot("secondaries", _ARG_1_[2]).weapon_id) then
            managers.blackmarket:equip_weapon("secondaries", _ARG_1_[2])
        end
        if Global.blackmarket_manager.melee_weapons[_ARG_1_[3]] and Global.blackmarket_manager.melee_weapons[_ARG_1_[3]].unlocked and managers.experience:current_level() >= Global.blackmarket_manager.melee_weapons[_ARG_1_[3]].level then
            managers.blackmarket:equip_melee_weapon(_ARG_1_[3])
        end
        local armor_table = {} -- another fix for tables
        if Global.blackmarket_manager.armors[_ARG_1_[4]] then
            for _FORV_12_, _FORV_13_ in pairs(tweak_data.upgrades.level_tree) do
                if _FORV_13_.upgrades then
                    for _FORV_17_, _FORV_18_ in ipairs(_FORV_13_.upgrades) do
                        if tweak_data.upgrades.definitions[_FORV_18_].armor_id then
                            armor_table[tweak_data.upgrades.definitions[_FORV_18_].armor_id] = _FORV_12_
                            print(tweak_data.upgrades.definitions[_FORV_18_].armor_id, _FORV_12_) -- WTF? Why? Can't do anything to help us...good job (sarcasm)
                        end
                    end
                end
            end
        end
        if Global.blackmarket_manager.armors[_ARG_1_[4]].unlocked and (not armor_table[_ARG_1_[4]] or managers.experience:current_level() >= armor_table[_ARG_1_[4]]) then
            managers.blackmarket:equip_armor(_ARG_1_[4])
        end
        if table.contains(managers.player:availible_equipment(1), _ARG_1_[5]) then
            managers.blackmarket:equip_deployable(_ARG_1_[5])
        end
    end

    function SkillTreeManager:_is_tree_identical_to_equipped(_ARG_1_) -- Finally, BTW...bootup skills didn't like this function
        for _FORV_5_, _FORV_6_ in pairs(self._global.skills) do
            if _ARG_1_[_FORV_5_].unlocked ~= _FORV_6_.unlocked then
                return false
            end
        end
        return true
    end
end