local set_GroupAITweakData_unit_categories_orig = GroupAITweakData._init_unit_categories
local set_GroupAITweakData_enemy_spawn_groups_orig = GroupAITweakData._init_enemy_spawn_groups
local set_GroupAITweakData_task_data_orig = GroupAITweakData._init_task_data

function GroupAITweakData:_init_unit_categories(difficulty_index)
	set_GroupAITweakData_unit_categories_orig(self, difficulty_index)
	
	local access_type_walk_only = {walk = true}
	local access_type_all = {walk = true, acrobatic = true}
	if difficulty_index == 5 then
		self.special_unit_spawn_limits = {
			tank = 25,
			taser = 22,
			spooc = 12,
			shield = 30
		}
		self.unit_categories.CS_swat_MP5 = {
			units = {
				Idstring("units/payday2/characters/ene_city_swat_1/ene_city_swat_1")
			},
			access = access_type_all
		}
		self.unit_categories.CS_swat_R870 = {
			units = {
				Idstring("units/payday2/characters/ene_city_swat_2/ene_city_swat_2")
			},
			access = access_type_all
		}
		self.unit_categories.FBI_swat_M4 = {
			units = {
				Idstring("units/payday2/characters/ene_city_swat_1/ene_city_swat_1")
			},
			access = access_type_all
		}
		self.unit_categories.FBI_swat_R870 = {
			units = {
				Idstring("units/payday2/characters/ene_city_swat_2/ene_city_swat_2")
			},
			access = access_type_all
		}
		self.unit_categories.FBI_tank = {
			units = {
				Idstring("units/payday2/characters/ene_bulldozer_1/ene_bulldozer_1"),
				Idstring("units/payday2/characters/ene_bulldozer_2/ene_bulldozer_2"),
				Idstring("units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3")
			},
			access = access_type_walk_only,
			special_type = "tank"
		}
	end
end

function GroupAITweakData:_init_enemy_spawn_groups(difficulty_index)
	set_GroupAITweakData_enemy_spawn_groups_orig(self, difficulty_index)
		
	if difficulty_index == 5 then
		self.enemy_spawn_groups.CS_defend_a = {
			amount = {10, 14},
			spawn = {
				{
					unit = "CS_cop_C45_R870",
					freq = 1,
					tactics = self._tactics.CS_cop,
					rank = 1
				}
			}
		}
		self.enemy_spawn_groups.CS_tazers = {
			amount = {3, 8},
			spawn = {
					{
					unit = "CS_tazer",
					freq = 1,
					amount_min = 3,
					amount_max = 5,
					tactics = self._tactics.CS_tazer,
					rank = 2
				},
				{
					unit = "CS_swat_MP5",
					freq = 3,
					amount_min = 5,
					tactics = self._tactics.CS_cop_stealth,
					rank = 1
				}
			}
		}
		self.enemy_spawn_groups.FBI_defend_b = {
			amount = {5, 7},
			spawn = {
				{
					unit = "FBI_suit_M4_MP5",
					freq = 1,
					amount_min = 5,
					tactics = self._tactics.FBI_suit,
					rank = 2
				},
				{
					unit = "FBI_swat_M4",
					freq = 1,
					tactics = self._tactics.FBI_suit,
					rank = 1
				}
			}
		}
		self.enemy_spawn_groups.FBI_defend_c = {
			amount = {5, 8},
			spawn = {
				{
					unit = "FBI_swat_M4",
					freq = 1,
					tactics = self._tactics.FBI_suit,
					rank = 1
				}
			}
		}
		self.enemy_spawn_groups.FBI_defend_d = {
			amount = {6, 9},
			spawn = {
				{
					unit = "FBI_heavy_G36",
					freq = 1,
					tactics = self._tactics.FBI_suit,
					rank = 1
				}
			}
		}
		self.enemy_spawn_groups.FBI_stealth_a = {
			amount = {4, 6},
			spawn = {
				{
					unit = "FBI_suit_stealth_MP5",
					freq = 1,
					amount_min = 3,
					tactics = self._tactics.FBI_suit_stealth,
					rank = 1
				},
				{
					unit = "CS_tazer",
					freq = 1,
					amount_max = 2,
					tactics = self._tactics.CS_tazer,
					rank = 2
				}
			}
		}
		self.enemy_spawn_groups.FBI_stealth_b = {
			amount = {4, 6},
			spawn = {
				{
					unit = "FBI_suit_stealth_MP5",
					freq = 1,
					amount_min = 3,
					tactics = self._tactics.FBI_suit_stealth,
					rank = 1
				},
				{
					unit = "FBI_suit_M4_MP5",
					freq = 1,
					tactics = self._tactics.FBI_suit,
					rank = 2
				}
			}
		}
		self.enemy_spawn_groups.FBI_swats = {
			amount = {7, 12},
			spawn = {
				{
					unit = "FBI_swat_M4",
					freq = 1,
					amount_min = 1,
					tactics = self._tactics.FBI_swat_rifle,
					rank = 2
				},
				{
					unit = "FBI_swat_M4",
					freq = 0.75,
					tactics = self._tactics.FBI_swat_rifle_flank,
					rank = 3
				},
				{
					unit = "FBI_swat_R870",
					freq = 0.5,
					amount_min = 1,
					tactics = self._tactics.FBI_swat_shotgun,
					rank = 1
				},
				{
					unit = "spooc",
					freq = 0.2,
					amount_max = 4,
					tactics = self._tactics.spooc,
					rank = 1
				}
			}
		}
		self.enemy_spawn_groups.FBI_heavys = {
			amount = {6, 9},
			spawn = {
				{
					unit = "FBI_heavy_G36",
					freq = 1,
					tactics = self._tactics.FBI_swat_rifle,
					rank = 1
				},
				{
					unit = "FBI_heavy_G36",
					freq = 0.75,
					tactics = self._tactics.FBI_swat_rifle_flank,
					rank = 2
				},
				{
					unit = "CS_tazer",
					freq = 0.25,
					amount_max = 3,
					tactics = self._tactics.CS_tazer,
					rank = 3
				}
			}
		}
		self.enemy_spawn_groups.FBI_shields = {
			amount = {6, 13},
			spawn = {
				{
					unit = "FBI_shield",
					freq = 1,
					amount_min = 2,
					tactics = self._tactics.FBI_shield_flank,
					rank = 3
				},
				{
					unit = "CS_tazer",
					freq = 0.75,
					amount_max = 2,
					tactics = self._tactics.CS_tazer,
					rank = 2
				},
				{
					unit = "FBI_heavy_G36",
					freq = 0.6,
					amount_max = 5,
					tactics = self._tactics.FBI_swat_rifle_flank,
					rank = 1
				}
			}
		}
		self.enemy_spawn_groups.FBI_tanks = {
			amount = {9, 14},
			spawn = {
				{
					unit = "FBI_tank",
					freq = 1,
					amount_min = 3,
					tactics = self._tactics.FBI_tank,
					rank = 1
				},
				{
					unit = "FBI_shield",
					freq = 0.5,
					amount_min = 2,
					amount_max = 4,
					tactics = self._tactics.FBI_shield_flank,
					rank = 3
				},
				{
					unit = "FBI_heavy_G36_w",
					freq = 0.75,
					amount_min = 3,
					amount_max = 5,
					tactics = self._tactics.FBI_heavy_flank,
					rank = 1
				}
			}
		}
		self.enemy_spawn_groups.single_spooc = {
			amount = {1, 3},
			spawn = {
				{
					unit = "spooc",
					freq = 1,
					amount_min = 1,
					amount_max = 3,
					tactics = self._tactics.spooc,
					rank = 1
				}
			}
		}
	end
end

function GroupAITweakData:_init_task_data(difficulty_index, difficulty)
	set_GroupAITweakData_task_data_orig(self, difficulty_index, difficulty)
	
	if difficulty_index == 5 then
		self.difficulty_curve_points = {0.5}
		self.smoke_and_flash_grenade_timeout = {6, 12}
		self.smoke_grenade_lifetime = 9
		self.besiege.assault.force = {1, 7, 10}
		self.besiege.assault.force_pool = {20, 60, 100}
		self.besiege.assault.force_balance_mul = {7.2, 8.4, 9.6, 12.8}
		self.besiege.assault.force_pool_balance_mul = {5.1, 7.3, 9.5, 12}
		self.besiege.recurring_group_SO = {
			recurring_cloaker_spawn = {
				interval = {15, 30},
				retire_delay = 25
			},
			recurring_spawn_1 = {
				interval = {30, 60}
			}
		}
		self.besiege.regroup.duration = {10, 10, 10}
		self.besiege.assault.anticipation_duration = {
			{30, 1},
			{30, 1},
			{45, 0.5}
		}
		self.besiege.assault.build_duration = 40
		self.besiege.assault.sustain_duration_min = {0, 80, 120}
		self.besiege.assault.sustain_duration_max = {0, 100, 140}
		self.besiege.assault.sustain_duration_balance_mul = {1, 1.3, 1.6 ,1.9}
		self.besiege.assault.delay = {10, 7.5, 5}
		self.besiege.assault.hostage_hesitation_delay = {35, 35, 35}
		self.besiege.assault.groups = {
			FBI_swats = {0.2, 0.4, 0.6},
			FBI_heavys = {0.1, 0.5, 0.75},
			FBI_shields = {0.4, 0.5, 0.6},
			FBI_tanks = {0.3, 0.4, 0.5},
			CS_tazers = {0.2, 0.3, 0.4},
			single_spooc = {0.1, 0.15, 0.2}
		}
		self.besiege.reenforce.interval = {5, 7, 10}
		self.besiege.reenforce.groups = {
			CS_defend_a = {1, 0, 0},
			FBI_defend_b = {1, 1, 0.5},
			FBI_defend_c = {0.5, 1, 0},
			FBI_defend_d = {0.25, 0.5, 1}
		}
		self.besiege.recon.interval = {5, 5, 5}
		self.besiege.recon.interval_variation = 5
		self.besiege.recon.force = {3, 5, 8}
		self.besiege.recon.groups = {
			FBI_stealth_a = {0.7 ,1 ,1},
			FBI_stealth_b = {0.45 ,0.6 ,1},
			single_spooc = {0 ,0 ,0}
		}
	end
end